<%-- Copyright (c) 2003 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved. --%>
<%@include file="shell/default.jspf"%>
<%@page import="com.sas.solutions.spm.webapp.common.i18n.RB"%>
<%@page import="com.sas.solutions.spm.webapp.scorecards.beans.CurrentDiagramDisplayContext"%>
<%@page import="com.sas.solutions.spm.webapp.scorecards.forms.DiagramDisplayForm"%>
<%@page import="com.sas.solutions.spm.webapp.diagram.GfxComponent"%>
<%@page import="com.sas.solutions.spm.webapp.portlet.util.SpmPortletKey"%>
<%@page import="java.util.Locale"%>
<%@page import="java.util.Date"%>
<%@page import="org.apache.batik.svggen.SVGSyntax"%>
<%@page import="com.sas.web.keys.CommonKeys"%>
<%@page import="com.sas.framework.webapp.helpers.FrameworkHelper"%>
<%@page import="com.sas.solutions.spm.webapp.common.util.SpmHelper" %>
<%@page import="com.sas.servlet.tbeans.html.DatePicker" %>
<%@page import="java.text.SimpleDateFormat" %>
<%@page import="com.sas.util.Strings" %>


<%@taglib uri='http://www.sas.com/taglib/sas-form' prefix='sas-f'%>


<sas-ui:Page key="vdiag"/>
<script type='text/ecmascript' src='scripts/checkAll.js'></script>

<%

    String scEntityKey = SpmHelper.getSessionContext(request).getEntityKey();

    Locale locale = FrameworkHelper.getUserLocale(request); // JAD 3/3/04: I18n punch list
    String appendedContext = SpmWebKey.SPM_PROJECT_ID + "=" + request.getAttribute(SpmWebKey.SPM_PROJECT_ID) + "&" +
                             SpmWebKey.SPM_SCORECARD_ID + "=" + request.getAttribute(SpmWebKey.SPM_SCORECARD_ID);
    CurrentDiagramDisplayContext ctx = (CurrentDiagramDisplayContext)session.getAttribute(SpmWebKey.SPM_CURRENT_CONTEXT_DIAGRAMDISPLAY);
    String thresholdPath = (String) request.getAttribute(SpmPortletKey.SPM_THRESHOLD_PATH);

	String elementDetailsUrl = (String) request.getAttribute(SpmWebKey.SPM_DETAILS_URL);

    String ctxPath = request.getContextPath();
    String id = ctx.getDiagramId();
    String path = ctx.getPath();

    path = path + "&isPortlet=false";
    
    String resetTransform = (String) request.getParameter(SpmWebKey.SPM_RESETTRANSFORM);
    if (resetTransform == null || resetTransform.length() == 0) 
        resetTransform = "false";

    String transform = (String) request.getParameter(SpmWebKey.SPM_TRANSFORM);
    if (transform == null)
    	transform = "";

    Date dateObj = ctx.getDate();
    String date = Long.toString(dateObj.getTime());
    String width = Integer.toString(ctx.getWidth());
    String height = Integer.toString(ctx.getHeight());
    request.setAttribute(SpmWebKey.SPM_ZOOM_MODEL, ctx.getZoomModel());

    String zoom = ctx.getZoom();

    String currentHighlight = ctx.getCurrentHighlight();

    DiagramDisplayForm  form = (DiagramDisplayForm)session.getAttribute("DiagramDisplayForm");
	String[] labels = form.getElementLabels();
   	String[] ids = form.getElementIds();
   	int numElements = 0;
	if (labels != null)
		numElements = labels.length;

	String commentsUrl = (String) request.getAttribute(SpmWebKey.SPM_COMMENTS_URL);
	String trendUrl = (String) request.getAttribute(SpmWebKey.SPM_TREND_URL);

	String commentsType = (String) request.getAttribute(SpmWebKey.CM_OBJECT_TYPE);
	
	String sdate = (String) request.getAttribute(SpmWebKey.SPM_DIAGRAM_DATE);
	if(sdate== null)
	   sdate =date;
	
	String promptLabel = Strings.escapeForJavaScript(RB.getString("print.preview.prompt.txt",locale));
%>


<sas-ui:PanelContainer imgHide="panel_toggle_hide" imgShow="panel_toggle_show">
    <sas-ui:SlidePanel>
        <table border="0" cellspacing="0" cellpadding="0" height="100%">
          <tr height="100%">
            <td valign="top">
              <jsp:include page="scTableTreePaneContents.jsp" flush="true"/>
            </td>
          </tr>
        </table>
    </sas-ui:SlidePanel>
    <sas-ui:Panel >
        <sas-ui:Message />
        <sas-ui:Help />


<logic:notPresent name="<%=SpmWebKey.DIAGRAMS_NONE_AVAILABLE%>">



<html:form action="/DisplayDiagrams" method="POST">

<html:hidden property="action" />
<html:hidden property="format" />
<input name="transform" type="hidden"/>
<input name="resettransform" type="hidden"/>
<input name="olddate" type="hidden" value="<%=sdate%>"/>

<input name="refresh" type="hidden" value="false"/> 
<logic:present name="<%=SpmWebKey.DIAGRAMS_USESVG%>">
<input name="currenthighlight" type="hidden" />
</logic:present>

<table cellpadding=0 cellspacing=0 width="100%" >
    <tr>
    	<td  width="100%" height="100%">
    		<TABLE cellspacing=0 cellpadding=0>
    			<tr>
				    <td class="spm_toolbartext"><span class='commonLabel'><sas-ui:Text key="DiagramDisplay.diagram.txt"/></span></td>
				    <td><table width="8px"></table></td>
				    <td class="spm_toolbartext"><span class='commonLabel'><sas-ui:Text key="DiagramDisplay.date.txt"/></span></td>
<logic:notPresent name="<%=SpmWebKey.DIAGRAMS_USESVG%>">
                    <td><table width="8px"></table></td>
				    <td class="spm_toolbartext"><span class='commonLabel'><sas-ui:Text key="DiagramDisplay.zoom.txt"/></span></td>
</logic:notPresent>
		    	</tr>
    			<tr>
			        <td>
			            <html:select property="diagram" style="spm_lowertoolbarcombo" size="1" value="<%=id%>">
			                <html:options labelProperty="labels" property="ids"/>
			            </html:select>
			        </td>
			        <td></td>

<logic:notPresent name="<%=SpmWebKey.DIAGRAMS_USESVG%>">
	        		<td nowrap>
			            <sas-ui:CalendarPicker   property="<%=SpmWebKey.SPM_DIAGRAM_DATE%>"/>
	        		</td>
			        <td></td>
	        		<td nowrap >
						<sas-f:ChoiceBox
							name="zoom"
							model="<%=SpmWebKey.SPM_ZOOM_MODEL%>"
							selectedItem="<%=ctx.getZoom()%>"
							customAttributes='class="spm_lowertoolbarcombo"'
							scope="request"
							/>
	        		</td>
	                <td><table width="5px"></table></td>
	        		<td nowrap >
	            		<sas-ui:Button useHidden="false" submitForm="false" actionKey="GoButton" function="javascript:doSubmit();" styleClass="buttonForControls" />
	        		</td>
</logic:notPresent>
<logic:present name="<%=SpmWebKey.DIAGRAMS_USESVG%>">
        			<td nowrap>
					
<sas-ui:CalendarPicker   property="<%=SpmWebKey.SPM_DIAGRAM_DATE%>"/>

				
					</td>
					
					<td>
            		<sas-ui:Button useHidden="false" submitForm="false" actionKey="GoButton" function="javascript:doSubmit();" styleClass="buttonForControls" />
					</td>
					<td>
            		<sas-ui:ThemeImage border="0" name="spacer" height="1px" width="4px" />					
					<img src="<sas-ui:ThemeImageRef image="MenuDivider.gif" />"  border="0">					
					<sas-ui:ThemeImage border="0" name="spacer" height="1px" width="4px" />
					</td>
					<td>
					<a title="<sas-ui:Text key="ZoomIn.txt"/>" href="javascript:doZoomIn();"><img id="_zoomIn" name="zoomIn" border="0" alt="<sas-ui:Text key="ZoomIn.txt"/>" src="images/ZoomIn.gif"></a>
					</td>
					<td>
					<a title="<sas-ui:Text key="ZoomOut.txt"/>" href="javascript:doZoomOut();"><img id=")zoomOut" name="zoomOut" border="0" alt="<sas-ui:Text key="ZoomOut.txt"/>" src="images/ZoomOut.gif"></a>
					</td>
					<td>					
					<a title="<sas-ui:Text key="ResetZoom.txt"/>" href="javascript:doSubmitReset();"><img id="_resetZoom" name="resetZoom" border="0" alt="<sas-ui:Text key="ResetZoom.txt"/>" src="images/ResetZoom.gif"></a>
					</td>
					<td>
					<sas-ui:ThemeImage border="0" name="spacer" height="1px" width="4px" />					
					<img src="<sas-ui:ThemeImageRef image="MenuDivider.gif" />"  border="0">
					<sas-ui:ThemeImage border="0" name="spacer" height="1px" width="4px" />
					</td>
					<td>
					<% if (numElements > 1) {
					%>
					<a title="<sas-ui:Text key="DiagramLocate.txt"/>" href="javascript:toggleLocate()"><img id="_resetHighlights" name="resetHighlights" border="0" alt="<sas-ui:Text key="DiagramLocate.txt"/>" src="images/DiagramLocate.gif"></a>
					<% } else { %>
					<a title="<sas-ui:Text key="DiagramLocate.txt"/>"><img id="_resetHighlights" name="resetHighlights" border="0" alt="<sas-ui:Text key="DiagramLocate.txt"/>" src="images/DiagramLocateDis.gif"></a>
					<% } %>
					</td>
					<td>
					<span style="visibility:hidden;position:absolute" >					
					<iframe id="locate" src="LocateElement.do" width="380" height="398" scrolling="no" frameborder="1"
						title="<sas-ui:Text key="DiagramLocate.txt"/>" >
						<sas-ui:Text key="browser.noiframe.txt"/>
					</iframe>
					</span>
					<sas-ui:ThemeImage border="0" name="spacer" height="1px" width="2px" />					
					</td>					
					<td>
					<sas-ui:ThemeImage border="0" name="spacer" height="1px" width="2px" />					
					<%  // Check for greater than 1 because the listbox has a blank item by default.
					if (numElements > 1) {
					%>
					<a title="<sas-ui:Text key="DiagramHighlight.txt"/>" href="javascript:toggleHighlight()"><img id="_resetHighlights" name="resetHighlights" border="0" alt="<sas-ui:Text key="DiagramHighlight.txt"/>" src="images/DiagramHighlight.gif"></a>
					<% } else { %>
					<a title="<sas-ui:Text key="DiagramHighlight.txt"/>"><img id="_resetHighlights" name="resetHighlights" border="0" alt="<sas-ui:Text key="DiagramHighlight.txt"/>" src="images/DiagramHighlightDis.gif"></a>
					<% } %>
					<span style="visibility:hidden;position:absolute" >					
					<iframe id="highlight" src="HighlightElementType.do" width="420" height="300" scrolling="no"
						title="<sas-ui:Text key="DiagramHighlight.txt"/>" >
						<sas-ui:Text key="browser.noiframe.txt"/>
					</iframe>
					</span>
					<sas-ui:ThemeImage border="0" name="spacer" height="1px" width="2px" />
					</td>
					<td>
					<a title="<sas-ui:Text key="ResetHighlights.txt"/>" href="javascript:clearHighlight()"><img id="_resetHighlights" name="resetHighlights" border="0" alt="<sas-ui:Text key="ResetHighlights.txt"/>" src="images/ResetDiagramHighlight.gif"></a>					
        			</td>
</logic:present>
	    	</tr>
	    </TABLE>
	    </td>
    </tr>
</table>

<script language="javascript">
<!--
	var firstG;
	
    function doSubmit() {
<logic:notPresent name="<%=SpmWebKey.DIAGRAMS_USESVG%>">
		var frm = document.forms['DiagramDisplayForm'];
	
		var tmp = frm.Spm_diagram_date.value;
		if (tmp != saveDate) {
			frm.refresh.value = "true";			
		} 
		frm.action.value = "get";
        frm.submit();
    	disableEverything();
     	return;
</logic:notPresent>
<logic:present name="<%=SpmWebKey.DIAGRAMS_USESVG%>">
        var frm = document.forms[1];
		var doc = document.spm_diagram.getSVGDocument();
		if (doc == null) {
            frm.submit();
        	disableEverything();
         	return;
		}
		var root = doc.getDocumentElement();

		var scale = root.getCurrentScale();
 	 	var translate = root.getCurrentTranslate();
 	 	
 	 	// Get the transform from the <g> element: 
 	 	//  <g transform="translate(-55,-46) scale(1) ">
 	 	var node = firstG;

 		var tx, ty, tscale;
 		var gx, gy, gscale;
 		
 		gx = translate.getX();
		gy = translate.getY();
		gscale = scale;
		
		var transform = node.getAttribute("transform");
 		// Get translate and scale
 		if  (transform.length > 0 && transform.indexOf("translate(") != -1) {
	 			
			// Parse the transform. 
			var piece = transform.substring(transform.indexOf("translate(") + 10);
			piece = piece.substring(0, piece.indexOf(")"));
			var pieces = piece.split(",");
			var gtransx = parseInt(pieces[0]);
			var gtransy = parseInt(pieces[1]);
			if (translate.getX() != null) 
				gx = translate.getX() + gtransx;
			else 
				gx =  gtransx;
			
			if (translate.getY() != null) 
				gy = translate.getY() + gtransy;
			else 
				gy = gtransy;
		}

 		if  (transform.length > 0 && transform.indexOf("scale") != -1) {
			var temp = transform.substring(transform.indexOf("scale(")+6);
			temp = temp.substring(0, temp.indexOf(")"));
			var strans = parseFloat(temp);
			gscale = scale * strans; 			
		}

 	 	var transform = getElement("transform");
 	 	transform.value = gx + " "  + gy + " "  + gscale;

	    frm.submit();
        disableEverything();
</logic:present>
   }

    function doZoomIn() {

        // Get the svg diagram, if it exists.
        if (document.spm_diagram == undefined) {
         	return;
		}
		var doc = document.spm_diagram.getSVGDocument();
		var root = doc.getDocumentElement();

		var scale = root.getCurrentScale();
		root.setCurrentScale(scale * 1.25);

   }

    function doZoomOut() {

        // Get the svg diagram, if it exists.
        if (document.spm_diagram == undefined) {
         	return;
		}
		var doc = document.spm_diagram.getSVGDocument();
		var root = doc.getDocumentElement();

		var scale = root.getCurrentScale();
		root.setCurrentScale(scale * .75);

   }

    function doSubmitReset() {

        if (document.spm_diagram == undefined) {
         	return;
		}
		var doc = document.spm_diagram.getSVGDocument();
		var root = doc.getDocumentElement();

		root.setCurrentScale(1);
		var p = root.getCurrentTranslate();
		p.setX(0);
		p.setY(0);
		
		// Find the root <g> element and reset the transform attribute
		try {
	 	 	firstG.removeAttribute("transform");
 	 	} catch (ex) {
 	 		// Exception thrown if the attribute doesn't exist.  We don't care.
 	 	}
 		
   }

	function getCurrentTransform() {
	
		var root = doc.getDocumentElement();

		var scale = root.getCurrentScale();
 	 	var translate = root.getCurrentTranslate();
 	 	
 	 	// Get the transform from the <g> element: 
 	 	//  <g transform="translate(-55,-46) scale(1) ">
 	 	var node = firstG;

 		var tx, ty, tscale;
 		var gx, gy, gscale;
 		
 		gx = translate.getX();
		gy = translate.getY();
		gscale = scale;
		
		var transform = node.getAttribute("transform");
 		// Get translate and scale
 		if  (transform.length > 0 && transform.indexOf("translate(") != -1) {
	 			
			// Parse the transform. 
			var piece = transform.substring(transform.indexOf("translate(") + 10);
			piece = piece.substring(0, piece.indexOf(")"));
			var pieces = piece.split(",");
			var gtransx = parseInt(pieces[0]);
			var gtransy = parseInt(pieces[1]);
			if (translate.getX() != null) 
				gx = translate.getX() + gtransx;
			else 
				gx =  gtransx;
			
			if (translate.getY() != null) 
				gy = translate.getY() + gtransy;
			else 
				gy = gtransy;
		}

 		if  (transform.length > 0 && transform.indexOf("scale") != -1) {
			var temp = transform.substring(transform.indexOf("scale(")+6);
			temp = temp.substring(0, temp.indexOf(")"));
			var strans = parseFloat(temp);
			gscale = scale * strans; 			
		}

 	 	return gx + " "  + gy + " "  + gscale;
	
	}

  function spmPrint(view)
   {
	var mainTbl = document.getElementById(view);
	if(mainTbl) {
	
		var stlshts = document.styleSheets;
		var themeFile, httpport;
		var sTheme = "SASTheme_default/themes/default/styles/";
		if (stlshts)
		{
			var cntStlshts = stlshts.length;
			var stlsht, themeLoc, pos;
			for (var i=0; i<cntStlshts; i++)
			{
				stlsht = stlshts[i];
				themeLoc = stlsht.href;
				if (themeLoc.length > 0)
				{
					pos = themeLoc.indexOf("/themes/");
					if (pos > 0)
					{
						sTheme = themeLoc.substring(themeLoc.lastIndexOf("/",pos-1)+1,themeLoc.lastIndexOf("/"));
						themeFile = themeLoc;
						httpport = themeLoc.substring(0, themeLoc.lastIndexOf("/"));
						break;
					}
				}
			}
		}
                
		var title= prompt('<%=promptLabel%>', ' ');
		if (title == null) title=' ';

		var printWin = window.open('about:blank','_blank'); // Open empty window
		var doc=printWin.document; // Get document handle for new window
		while(!doc.body) {};
		var HTMLtop ='<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
		//Diagrams cannot be wrapped in a table.
        	if(view != '_spm_diagram')
			HTMLtop = HTMLtop + '<TABLE cellpadding=12 width=100%><TR><TD>';

		HTMLtop = HTMLtop + '<html>';
		
		HTMLtop = HTMLtop + '<link rel="stylesheet" href="' + themeFile + '" type="text/css" media="ALL" />';
		HTMLtop = HTMLtop + '<link rel="stylesheet" href="' + httpport + '/sasStyle.css" type="text/css" media="ALL" />';
		HTMLtop = HTMLtop + '<link rel="stylesheet" href="' + httpport + '/Portal.css" type="text/css" media="ALL" />';
		HTMLtop = HTMLtop + '<link rel="stylesheet" href="' + httpport + '/sasScorecard.css" type="text/css" media="ALL" />';
		HTMLtop = HTMLtop + '</head><body marginheight="0" marginwidth="0">';
		
		if(view != '_spm_diagram')
			HTMLtop = HTMLtop + '</TD></TR></TABLE>';
			
		HTMLtop = HTMLtop + '<B><CENTER>' + title + '</b></center>';
		var HTMLend = '</body></html>';
		doc.write(HTMLtop+mainTbl.outerHTML+HTMLend);
	}else{
		//contents not displayed yet
	}

   }

//-->
</script>
</html:form>
<script type='text/ecmascript' src='scripts/customerSVG.js'></script>


<logic:present name="<%=SpmWebKey.DIAGRAMS_USESVG%>">



<div id="_spm_diagram">

<script language="javascript">
   <!--


   /*  This function clears any existing highlights.  We manage highlighting by changing
       opacacity for elementtypegroup, link, node, and some rect elements.  All of these
       are surfaced via <g> element with our "spmType" attribute.  Simply go through all
       the <g> elements and modify ours accordingly.
    */

    function clearHighlight( )
	{
		// Clear the highlight value in our two forms.
		var frm =document.forms[2];
		if (frm != null)
			frm.currenthighlight.value = "";
		frm =document.forms[1];
		if (frm != null)
			frm.currenthighlight.value = "";
			
		// Clear the locate window.
		try {
			window.frames["locate"].DeSelectOptions();
			} catch(obj) {};

		var doc = document.spm_diagram.getSVGDocument();
		var root = doc.getDocumentElement();
		var list = root.getElementsByTagName("<%=SVGSyntax.SVG_G_TAG%>");

		// If needed, deselect any currently selected.
		if (lastSelected != null) {
			lastSelected.setAttribute("visibility", "hidden");

			// Also stop any animation.
			stopAnimation(lastSelected)
		}

		var i;

		// For each one, see if it has an attribute "spmType".  Ignore the first.
		for  (i = 0; i < list.getLength(); i++) {

			var gElement = list.item(i);
			var spmType = gElement.getAttributeNS("<%=GfxComponent.SPM_NAMESPACEURI%>","<%=GfxComponent.SPM_TYPE_ATTRIBUTENONS%>");

			// If it's not one of ours, skip.
			if (spmType == null) {
				continue;
			}

			var id = gElement.getAttribute("id");

			if (spmType == "<%=GfxComponent.SPM_TYPE_CANVAS%>") {
				gElement.setAttribute("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>", "1.0");
				gElement.setAttribute("<%=SVGSyntax.SVG_STROKE_OPACITY_ATTRIBUTE%>", "1.0");
			} else
			if (spmType == "<%=GfxComponent.SPM_TYPE_LINK%>") {
				gElement.setAttribute("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>", "1.0");
				gElement.setAttribute("<%=SVGSyntax.SVG_STROKE_OPACITY_ATTRIBUTE%>", "1.0");
			} else
			if (spmType == "<%=GfxComponent.SPM_TYPE_ELEMENTTYPEGROUP%>") {
				gElement.setAttribute("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>", "1.0");
				gElement.setAttribute("<%=SVGSyntax.SVG_STROKE_OPACITY_ATTRIBUTE%>", "1.0");
				var rectList = gElement.getElementsByTagName("<%=SVGSyntax.SVG_RECT_TAG%>");
				var j = 0;
				while (j < rectList.getLength()) {
					var r = rectList.item(j);
					j = j + 1;
					var atts = r.getAttributes();
					var type = atts.getNamedItemNS("<%=GfxComponent.SPM_NAMESPACEURI%>","<%=GfxComponent.SPM_TYPE_ATTRIBUTENONS%>");
					if (type != null && type.getNodeValue() == "<%=GfxComponent.SPM_TYPE_IMAGEHIGHLIGHT%>") {
						var a = atts.getNamedItem("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>");

						a.setNodeValue("0");
					}
				}
			}
		}

	}

   /*  This function highlights all element nodes of a specific element type.  It actually
       highlight those nodes by greying out other content.
    */

    function doHighlight(eid)
	{

		if (eid == null || eid == "" || eid == "null") {
			clearHighlight();
			return;
		}

		// If this is an association highlight, ignore.
		if (eid.indexOf(":") != -1)
			return;

		var frm =document.forms[2];
		if (frm != null)
			frm.currenthighlight.value = eid;
		frm =document.forms[1];
		if (frm != null)
			frm.currenthighlight.value = eid;


		var doc = document.spm_diagram.getSVGDocument();
		var root = doc.getDocumentElement();
		var list = root.getElementsByTagName("<%=SVGSyntax.SVG_G_TAG%>");

		// Verify that there are nodes of this type.
		var exists = 0;
		for  (i = 0; i < list.getLength(); i++) {

			var gElement = list.item(i);
			var spmType = gElement.getAttributeNS("<%=GfxComponent.SPM_NAMESPACEURI%>","<%=GfxComponent.SPM_TYPE_ATTRIBUTENONS%>");

			// If it's not one of ours, skip.
			if (spmType == null) {
				continue;
			}

			var id = gElement.getAttribute("id");

			// If this is
			if (spmType == "<%=GfxComponent.SPM_TYPE_ELEMENTTYPEGROUP%>")
				if ( id == eid)
					exists = 1;
		}

		if (exists == 0)
			return;


		// If needed, deselect any currently selected.
		if (lastSelected != null) {
			lastSelected.setAttribute("visibility", "hidden");

			// Also stop any animation.
			stopAnimation(lastSelected)
		}

		var i;

		// For each one, see if it has an attribute "spmType".  Ignore the first.
		for  (i = 0; i < list.getLength(); i++) {

			var gElement = list.item(i);
			var spmType = gElement.getAttributeNS("<%=GfxComponent.SPM_NAMESPACEURI%>","<%=GfxComponent.SPM_TYPE_ATTRIBUTENONS%>");

			// If it's not one of ours, skip.
			if (spmType == null) {
				continue;
			}

			var id = gElement.getAttribute("id");

			// If this is a link, gray it out.
			if ( spmType == "<%=GfxComponent.SPM_TYPE_LINK%>" || spmType == "<%=GfxComponent.SPM_TYPE_CANVAS%>") {
				gElement.setAttribute("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>", "0.1");
				gElement.setAttribute("<%=SVGSyntax.SVG_STROKE_OPACITY_ATTRIBUTE%>", "0.1");
			} else
			if (spmType == "<%=GfxComponent.SPM_TYPE_ELEMENTTYPEGROUP%>") {

				// If this is not the selected group, de-emphasize it.
				if ( id != eid) {
					// De-emphasize this element.
					gElement.setAttribute("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>", "0.1");
					gElement.setAttribute("<%=SVGSyntax.SVG_STROKE_OPACITY_ATTRIBUTE%>", "0.1");

					// If there's an "imageHighlight" rect that is a child element of this
					// <g> element, we need to deal with it
					// separately becuase it's used to change an external
					// image drawn in the same spot.

					var rectList = gElement.getElementsByTagName("<%=SVGSyntax.SVG_RECT_TAG%>");
					var j = 0;
					while (j < rectList.getLength()) {
						var r = rectList.item(j);
						j = j + 1;
						var atts = r.getAttributes();
						var type = atts.getNamedItemNS("<%=GfxComponent.SPM_NAMESPACEURI%>","<%=GfxComponent.SPM_TYPE_ATTRIBUTENONS%>");
						if (type != null && type.getNodeValue() == "<%=GfxComponent.SPM_TYPE_IMAGEHIGHLIGHT%>") {
							var a = atts.getNamedItem("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>");
							a.setNodeValue("0.9");
						}
					}
				} else {
					// Reset to normal.
					gElement.setAttribute("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>", "1.0");
					gElement.setAttribute("<%=SVGSyntax.SVG_STROKE_OPACITY_ATTRIBUTE%>", "1.0");
					var rectList = gElement.getElementsByTagName("<%=SVGSyntax.SVG_RECT_TAG%>");
					var j = 0;
					while (j < rectList.getLength()) {
						var r = rectList.item(j);
						j = j + 1;
						var atts = r.getAttributes();
						var type = atts.getNamedItemNS("<%=GfxComponent.SPM_NAMESPACEURI%>","<%=GfxComponent.SPM_TYPE_ATTRIBUTENONS%>");
						if (type != null && type.getNodeValue() == "<%=GfxComponent.SPM_TYPE_IMAGEHIGHLIGHT%>") {
							var a = atts.getNamedItem("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>");
							a.setNodeValue("0");
						}
					}  // end while
				} // end else
			}
		}  // end for


	}


	/*
		This function "locates" an element in the diagram by highlighting it, actually by
		drawing a red rectangle around it.  The element is also moved into view.
	*/

	var lastSelected;   // This keeps track of the last one selected so that it can
						// be deselected.

	/*
	 	Find the <animate> child element and stop it's animation.
	*/
	function stopAnimation(element) {
		for( var anode = element.getFirstChild() ; anode ; anode = anode.getNextSibling() ) {
			if (anode.getNodeName() == "<%=SVGSyntax.SVG_ANIMATE_TAG%>") {
				anode.endElementAt(0);
				break;
			}
		}
	}

    function doLocate( eid)
	{

		var doc = document.spm_diagram.getSVGDocument();

		var root = doc.getDocumentElement();
		var ls = root.getElementsByTagName("<%=SVGSyntax.SVG_G_TAG%>");
 	 	var	g = ls.item(0);

		// We need to actually find the requested element and highlight and move it into view.
		if (eid != "") {

			var temp = doc.getElementById(eid);

			// If needed, deselect any currently selected.
			if (lastSelected != null) {
				lastSelected.setAttribute("visibility", "hidden");

				// Also stop any animation.
				stopAnimation(lastSelected)
			}

			// Get the selection rect
			for( var node = temp.getFirstChild() ; node ; node = node.getNextSibling() ) {
				if (node.getNodeName() == "<%=SVGSyntax.SVG_RECT_TAG%>") {
					var atts = node.getAttributes();
					var type = atts.getNamedItemNS("<%=GfxComponent.SPM_NAMESPACEURI%>", "<%=GfxComponent.SPM_TYPE_ATTRIBUTENONS%>");
					if (type != null && type.getNodeValue() == "selectionrect") {
						var visibility = atts.getNamedItem("visibility");
						if (visibility != null)
							visibility.setNodeValue("visible");
						// Start the animation.
						var rchildren = node.getChildNodes();
						var j = 0;
						while ( j < rchildren.getLength()) {
							var anode = rchildren.item(j);
							j++;
							if (anode.getNodeName() == "<%=SVGSyntax.SVG_ANIMATE_TAG%>") {
									anode.beginElement();
									break;
							}
						}
					}
					// Update our global.
					var id = atts.getNamedItem("id");
					lastSelected = doc.getElementById(id.getNodeValue());
					break;
				}
			}

	        var ctm = g.getCTM();

            var oldTranslateX = -ctm.e;
	        var oldTranslateY = -ctm.f;

			var x = temp.getAttributeNS("<%=GfxComponent.SPM_NAMESPACEURI%>","<%=GfxComponent.SPM_X_ATTRIBUTENONS%>");
			var y = temp.getAttributeNS("<%=GfxComponent.SPM_NAMESPACEURI%>","<%=GfxComponent.SPM_Y_ATTRIBUTENONS%>");

			var newX;
			var newY;

			newX = oldTranslateX - x;
			newX += 100;
			newY = oldTranslateY - y;
			newY += 100;

			var newctm = ctm.translate(newX, newY);

			g.setAttribute("transform" , "matrix(" + newctm.a + "," + newctm.b + "," + newctm.c + ","  + newctm.d + ","  + newctm.e + ","  + newctm.f + ")");

			var rectList = temp.getElementsByTagName("<%=SVGSyntax.SVG_RECT_TAG%>");
			var j = 0;
			while (j < rectList.getLength()) {
				var r = rectList.item(j);
				j = j + 1;
				var atts = r.getAttributes();
				var type = atts.getNamedItemNS("<%=GfxComponent.SPM_NAMESPACEURI%>","<%=GfxComponent.SPM_TYPE_ATTRIBUTENONS%>");
				if (type != null && type.getNodeValue() == "<%=GfxComponent.SPM_TYPE_IMAGEHIGHLIGHT%>") {
					var a = atts.getNamedItemNS(null,"<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>");
					a.setNodeValue("0");
					break;
				}

			}
		} else
		{
			if (lastSelected != null) {
				lastSelected.setAttribute("visibility", "hidden");

				// Also stop any animation.
				stopAnimation(lastSelected)
			}
		}


   }
    /* This function highlights a selected association.  This involves finding element node
       sections in the document that are NOT members of the "from" element type or the "to" element
       type and changing their fill-opacity such that they appear faded.  Element node
       sections are identified as <g> elements with "spmType=elementtypegroup"

       Similarly, we find "links" that go between "from" nodes and "to" nodes.  Links are
       identified in the documents as <g> elements with an attribute "spmType=link".  They also
       have an "spmId" attribute of the form "fromelementtypeguid#toelementtypeguid".  So, links which do
       not have both guids (in the correct order) will be "greyed out".
       */

    function doAssociations(s)
	{

		clearHighlight();

		if (s == null || s == "" || s == "null") {
			return;
		}

		// Check that the s has the correct form.
		if (s.indexOf(":") == -1)
			return;

		var frm =document.forms[2];
		if (frm != null)
			frm.currenthighlight.value = s;
		frm =document.forms[1];
		if (frm != null)
			frm.currenthighlight.value = s;

		var items = s.split(":");
		var fromId = items[0];
		var toId = items[1];

		if (fromId == null)
		 	return;

		var doc = document.spm_diagram.getSVGDocument();

		// For each element, get the element's style object, then set
		// its opacity based on whether no elements are highlighted
		// (original setting), some other element is highlighted
		// (de-emphasize), or this element is highlighted (emphasize).

		var root = doc.getDocumentElement();
		var ls = root.getElementsByTagName("<%=SVGSyntax.SVG_G_TAG%>");
 	 	var	g = ls.item(0);
		var i;
		var j;
		var temp1;
		var s;
		var type;
		var linkAttr;
		var gElement;
		var attrlist;
		var tempE;
		var rectList;
		var atts;
		var type1;
		var r;
		var a;
		var spmId;

		for( gElement = g.getFirstChild() ; gElement ; gElement = gElement.nextSibling ) {

			attrlist = gElement.getAttributes();

			// If it doesn't have any attributes, ignore.
			if (attrlist == null) {
				//gElement.setAttribute("fill-opacity", "0.1");
				continue;
			}
			linkAttr = attrlist.getNamedItemNS("<%=GfxComponent.SPM_NAMESPACEURI%>","<%=GfxComponent.SPM_TYPE_ATTRIBUTENONS%>");
			if (linkAttr == null)
				continue;

			temp1 = attrlist.getNamedItem("id");
			s = temp1.getNodeValue();

			temp1 = attrlist.getNamedItemNS("<%=GfxComponent.SPM_NAMESPACEURI%>", "<%=GfxComponent.SPM_ID_ATTRIBUTENONS%>");
			if (temp1 != null)
				spmId = temp1.getNodeValue();

			// We need to get the 'element' type, not the 'node' type.
			tempE = doc.getElementById(s);

			type = linkAttr.getNodeValue();

			// Treat the id attribute differently based on the type.
			if (type == "<%=GfxComponent.SPM_TYPE_CANVAS%>") {
					tempE.setAttribute("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>", "0.1");
					tempE.setAttribute("<%=SVGSyntax.SVG_STROKE_OPACITY_ATTRIBUTE%>", "0.1");
			} else
			if (type == "<%=GfxComponent.SPM_TYPE_LINK%>" ) {
			    // If this link's id is of the form "fromid:toid" then show it.
			    // Otherwise gray it out.
				if ((spmId.indexOf("#"+toId) != -1) &&  (spmId.indexOf(fromId) == 0)) {
					tempE.setAttribute("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>", "1.0");
					tempE.setAttribute("<%=SVGSyntax.SVG_STROKE_OPACITY_ATTRIBUTE%>", "1.0");
				}
				else {
					tempE.setAttribute("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>", "0.1");
					tempE.setAttribute("<%=SVGSyntax.SVG_STROKE_OPACITY_ATTRIBUTE%>", "0.1");
				}
			} else
			if (type == "<%=GfxComponent.SPM_TYPE_ELEMENTTYPEGROUP%>") {

				// If this <g> element's id does NOT contain either element type id as the first part, then
				// de-emphasize it.
				if ( s.indexOf(fromId) != 0 && s.indexOf(toId) != 0) {
					tempE.setAttribute("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>", "0.1");

					// If there's an "imageHighlight" rect that is a child element of this
					// <g> element, we need to deal with it
					// separately becuase it's used to change an external
					// image drawn in the same spot.

					rectList = tempE.getElementsByTagName("<%=SVGSyntax.SVG_RECT_TAG%>");
					j = 0;
					while (j < rectList.getLength()) {
						r = rectList.item(j);
						j = j + 1;
						atts = r.getAttributes();
						type1 = atts.getNamedItemNS("<%=GfxComponent.SPM_NAMESPACEURI%>","<%=GfxComponent.SPM_TYPE_ATTRIBUTENONS%>");
						if (type1 != null && type1.getNodeValue() == "<%=GfxComponent.SPM_TYPE_IMAGEHIGHLIGHT%>") {
							a = atts.getNamedItem("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>");
							a.setNodeValue("0.9");
						}
					}
				}  else
				{
					// Reset to normal.
					tempE.setAttribute("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>", "1.0");
					rectList = tempE.getElementsByTagName("<%=SVGSyntax.SVG_RECT_TAG%>");
					j = 0;
					while (j < rectList.getLength()) {
						r = rectList.item(j);
						j = j + 1;
						atts = r.getAttributes();
						type1 = atts.getNamedItemNS("<%=GfxComponent.SPM_NAMESPACEURI%>","<%=GfxComponent.SPM_TYPE_ATTRIBUTENONS%>");
						if (type1 != null && type1.getNodeValue() == "<%=GfxComponent.SPM_TYPE_IMAGEHIGHLIGHT%>") {
							a = atts.getNamedItem("<%=SVGSyntax.SVG_FILL_OPACITY_ATTRIBUTE%>");
							a.setNodeValue("0");
						}
					}
				}
			}
		}
   }


	// This function is called during the onload handling of the SVG document.  See diagramSVG.js
	function restoreHighlight() {
		doAssociations("<%=ctx.getCurrentHighlight()%>");
		doHighlight("<%=ctx.getCurrentHighlight()%>");
	}
	
	
	
var mousex;
var mousey;
function saveMouse()
{
    mouseX = window.event.x;
    mouseY = window.event.y;

}
function showPopupMenuNearMouse(menuId, foo)
{

    popMenu = getElement(menuId);
    if (popMenu.style.display == 'none')
    {

        popMenu.style.display = 'block';

        popMenu.style.posLeft = mouseX;

        // For some reason, the popup comes up too low.  That's
        // why the -30 below....
        popMenu.style.posTop = mouseY - 30;
    }
    else
        popMenu.style.display = 'none';
}


	function toggleCalendar()
	{
	    var calendarDiv = document.getElementById("calendar");
	    var visibility = calendarDiv.style.visibility;
	    if (visibility == 'visible')
	    {
	        calendarDiv.style.visibility = 'hidden';
		    calendarDiv.style.posWidth = 0;
		    calendarDiv.style.posHeight = 0;
	    }
	    else
	    {
	        calendarDiv.style.visibility = 'visible';
	        calendarDiv.style.posWidth = 226;
		    calendarDiv.style.posHeight = 226;
	    }
	}

	function toggleLocate()
	{
	    var locate = document.getElementById("locate");
	    var visibility = locate.style.visibility;
	    if (visibility == 'visible')
	    {
	        locate.style.visibility = 'hidden';
	    }
	    else
	    {
	    	hideHighlight();
	        locate.style.visibility = 'visible';
	    }
	}
	
	function hideLocate()
	{
	    var locate = document.getElementById("locate");
	    locate.style.visibility = "hidden";
	}

	
	function toggleHighlight()
	{
	    var highlight = document.getElementById("highlight");
	    var visibility = highlight.style.visibility;
	    if (visibility == 'visible')
	    {
	        highlight.style.visibility = 'hidden';
	    }
	    else
	    {
	    	hideLocate();
	        highlight.style.visibility = 'visible';
	    }
	}

	function expandCalendar()
	{
	    var calendarDiv = document.getElementById("calendar");
	    calendarDiv.style.posWidth = 226;
	    calendarDiv.style.posHeight = 226;
	}

	function resetCalendar()
	{
	    var calendarDiv = document.getElementById("calendar");
		    calendarDiv.style.posWidth = 140;
		    calendarDiv.style.posHeight = 24;
	}

	function hideHighlight()
	{
	    var highlight = document.getElementById("highlight");
	    if (highlight != null)
		    highlight.style.visibility = "hidden";
	}



//-->
</script>

<EMBED type="image/svg+xml" id="spm_diagram" NAME="spm_diagram" width="100%" height="100%" SRC="<%=ctxPath%>/servlet/Spm?diagram=<%=id%>&tag=diagram&action=get&format=svg&path=<%=path%>&<%=SpmWebKey.SPM_DATE%>=<%=date%>&<%=SpmWebKey.SPM_RESETTRANSFORM%>=<%=resetTransform%>&<%=SpmWebKey.SPM_TRANSFORM%>=<%=transform%>" PLUGINSPAGE="http://www.adobe.com/svg/viewer/install/" wmode="transparent"/>

</div>
<div id="_spm_diagram_error" style="display:none">
	<table cellpadding=0 cellspacing=0>
	<tr>
	    <td class="leftpadding"><img src="<sas-ui:ThemeImageRef image="spacer.gif" />"  border="0" height="10"></td>
	</tr>
	<tr>
		<td class="leftpadding">
			<sas-ui:Text key="diagramFormatSVGNotInstalled2.txt"/>
			<a  href="http://www.adobe.com/svg/viewer/install/main.html" target="_new" ><sas-ui:Text key="diagramFormatSVGNotInstalled3.txt"/></a>
		</td>
	</tr>
	<tr>
	    <td class="leftpadding"><img src="<sas-ui:ThemeImageRef image="spacer.gif" />"  border="0" height="10"></td>
	</tr>
	</table>
</div>

<script language="VBScript">
Function isSVGControlInstalled()
	on error resume next
	isSVGControlInstalled = IsObject(CreateObject("Adobe.SVGCtl"))
end Function
</script>

<script language="javascript">

	    if (!isSVGControlInstalled())  {

        	var svgelement = document.getElementById("_spm_diagram");
        	if (svgelement != null)
        		svgelement.style.display = "none";
        	svgelement = document.getElementById("_spm_diagram_error");
        	if (svgelement != null)
        		svgelement.style.display = "block";
        }

</script>

</logic:present>


<logic:notPresent name="<%=SpmWebKey.DIAGRAMS_USESVG%>">
<div id="_spm_diagram" height="100%">
<iframe id="spm_diagram" onclick="saveMouse()"  width="100%" height="100%" scrolling="no" frameborder="0"
    src="<%=path%>">
</iframe>
</div>
</logic:notPresent>


</logic:notPresent>
    </sas-ui:Panel>
</sas-ui:PanelContainer>


<form name="details_form" id="details_form" method="post">
<input name="transform" type="hidden"/>
<input name="currenthighlight" type="hidden" />
</form>

<form name="navigate_form" id="navigate_form" method="get">
</form>

<script language="javascript">
	function elementDetailsSvg( id, target )
	{
		var url;
	   	url = "<%=elementDetailsUrl%>";   	
	
		var frm =document.forms['details_form'];
		frm.action = url;
	    frm.target = target;
	        
	    var targetList = document.getElementsByName("spm_diagram");
	    var svgd = targetList[0];
		var doc = svgd.getSVGDocument();
		var root = doc.getDocumentElement();
		
		var scale = root.getCurrentScale();
	 	var translate = root.getCurrentTranslate();
	
	 	frm.transform.value = translate.getX() + " "  + translate.getY() + " "  + scale;
		
		url = url + "&<%=SpmWebKey.SPM_ELEMENTDETAILS_ID%>=" + id +	    
				"&currenthighlight=" + frm.currenthighlight.value + 	    
				"&transform=" + frm.transform.value  ;
		// Add date if not already in.
		if (url.indexOf("&dt=") == -1 && url.indexOf("&date=") == -1) 
			url = url + "&date=" + "<%=date%>" ;
	    parent.document.location.href = url;
	    
	}

	function myNavigate( url, target )
	{
		// If the target is our webapp, add some parameters so that the current transform
		// can be saved.
		
		url = "<%=ctxPath%>" + url;
	
	    if (url.indexOf("<%=request.getContextPath()%>") != -1) {
	       	var frm = document.forms['details_form'];
	
	    	var doc = document.spm_diagram.getSVGDocument();
			var root = doc.getDocumentElement();
	
			var scale = root.getCurrentScale();
	 		var translate = root.getCurrentTranslate();
	
	    	url = url +"&diagram=" + "<%=id%>" + "&transform=" + translate.getX() + " "  + translate.getY() + " "  + scale  + "&currenthighlight=" + frm.currenthighlight.value;
			// Add date if not already in.
			if (url.indexOf("&dt=") == -1 && url.indexOf("&<%=SpmWebKey.SPM_DIAGRAM_DATE%>=") == -1) 
				url = url + "&<%=SpmWebKey.SPM_DIAGRAM_DATE%>=" + "<%=date%>" ;
	
	    	frm.action = url;
	    	frm.target = target;
	    	frm.submit();
	    } else {
	       	var frm = document.forms['navigate_form'];
	
	    	frm.action = url;
	    	frm.target = target;
	    	frm.submit();
		}
	
	}
	
	function myNavigateSVG( url, target )
	{
	    
       	var frm = document.forms['navigate_form'];
    	frm.action = url;
    	frm.target = target;
    	frm.submit();
    	return;
	    
	}
	
	
   function elementDetails(id) {

   		var url = "<%=elementDetailsUrl%>" +  "&<%=SpmWebKey.SPM_DIAGRAM_DATE%>=" + "<%=date%>" + "&<%=SpmWebKey.SPM_ELEMENTDETAILS_ID%>=" + id ;

    	parent.document.location.href = url;
   }

   function doThreshold(type, eid, cid, period) {

	   	var frm = document.forms['details_form'];
	   	var url = "<%=thresholdPath%>" + "&<%=SpmWebKey.SPM_DIAGRAM_DATE%>=" + "<%=date%>" + "&type=" + type + "&elementId="  + eid + "&columnId="  + cid + "&periodId="  + period + "&currenthighlight=" + frm.currenthighlight.value;
    	parent.document.location.href = url;

   }

	/* This calls the comment manager on behalf of SVG or PNG diagrams.
	   It performs the call by submitting a form.  This is required since the
	   browser will add a "referer" to the request header which is expected by
	   server side filters.  I.e. parent.document.location.href = url;  DOES NOT
	   work because the "referer" is not included.
	*/
   function doComments2( id, sid) {
	
	   	var url = "<%=commentsUrl%>";
	   	url = url.replace("<%=SpmWebKey.IDPARAMETER%>", id);
	   	url = url + "&scorecardId=" + sid;
	   	parent.document.location.href = url;
	   	
   }

   
   function doDirective2(url, target) {
	   
	   window.open(url, target);
	}





   function doTrend2(name, id, period, scorecard) {

<logic:present name="<%=SpmWebKey.SPM_TREND_URL%>">

		var url = "<%=trendUrl%>&o_nm=" + encodeURI(name) +
			"&o_id=" + id + "&scorecardId=" + scorecard;

    	document.location.href = url;
</logic:present>
<logic:notPresent name="<%=SpmWebKey.SPM_TREND_URL%>">
		alert("<%=RB.getString("trendWarning.txt", locale)%>");
</logic:notPresent>
   }
<logic:notPresent name="<%=SpmWebKey.DIAGRAMS_USESVG%>">   
	// Save the initial date.
	var frm = document.forms['DiagramDisplayForm'];
	
	var saveDate;
	if(frm != null)
	{
	   if(frm.Spm_diagram_date != null)
	       saveDate = frm.Spm_diagram_date.value;
	}
</logic:notPresent>



	function diagramEdit() {
		window.open("<%=ctxPath%>" + "/DiagramEdit.do?action=edit&format=htm&<%=appendedContext%>", "editdiagram");
	}
//-->	
</script>

<script language="javascript">
	function adjustFrame(scrollWidth, scrollHeight){
		var id = "rightPanel"

		document.getElementById("spm_diagram").style.height = scrollHeight  + "px";
		document.getElementById("spm_diagram").style.width= scrollWidth + "px"
			
		document.getElementById(id).style.height = scrollHeight + 100 + "px";
		document.getElementById(id).style.width=(scrollWidth+50)+"px"
	}
</script>


<%@include file="savePanel.inc"%>
