<%-- Copyright (c) 2003 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved. --%>
<%@include file="shell/default.jspf"%>
<%@page import="com.sas.actionprovider.ActionOrderList"%>
<%@page import="com.sas.actionprovider.HttpActionProvider"%>
<%@page import="com.sas.actionprovider.support.ActionProviderSupportTypes"%>
<%@page import="com.sas.actionprovider.support.tableview.HttpTableViewSupport"%>
<%@page import="com.sas.servlet.tbeans.tableview.html.TableViewComposite"%>
<%@page import="com.sas.servlet.tbeans.tableview.html.TableView"%>
<%@page import="com.sas.servlet.tbeans.models.JavaScriptNode"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.Locale"%>
<%@page import="java.util.HashMap"%>
<%@page import="java.util.Map"%>
<%@page import="com.sas.solutions.spm.webapp.portlet.util.SpmPortletKey"%>
<%@page import="com.sas.solutions.spm.webapp.portlet.actions.SpmPortletDisplayAction"%>
<%@page import="javax.swing.ComboBoxModel"%>
<%@page import="javax.swing.table.TableModel"%>
<%@page import="com.sas.framework.webapp.helpers.FrameworkHelper"%>
<%@page import="com.sas.swing.models.SortableTableModelAdapter"%>
<%@page import="javax.swing.table.DefaultTableModel"%>
<%@page import="com.sas.solutions.spm.webapp.wizards.sde.forms.SDESelectScorecardsForm"%>
<%@page import="com.sas.util.Strings"%>


<%@taglib uri="http://www.sas.com/taglib/sas-dataviewers" prefix="sas-dv"%>
<%@taglib uri="http://www.sas.com/taglib/sas-util" prefix="sas-u"%>


<%@taglib uri="http://www.sas.com/taglib/sas-form" prefix="sas-f"%>

<%@page import="com.sas.solutions.spm.webapp.common.i18n.RB"%>

<%@page import="com.sas.util.SimpleTemplate"%>
<%@page import="com.sas.servlet.tbeans.navigationbar.html.TableRowNavigationBar"%>
<%@page import="com.sas.servlet.tbeans.navigationbar.html.NavigationBarRowScrollingElement"%>
<%@page import="com.sas.servlet.tbeans.navigationbar.html.TableColumnNavigationBar"%>
<%@page import="com.sas.servlet.tbeans.navigationbar.html.NavigationBarColumnScrollingElement"%>
<%@page import="java.util.Collection"%>
<%@page import="java.util.Iterator"%>
<%@page import="com.sas.actionprovider.HttpAction"%>

<sas-ui:Page key="portlet_spmdataentry"/>


<%
    
    String portalPg = request.getParameter("portalPg");
    synchronized(getLockString(portalPg)) {  // synchronize on the portal page metadataid string
    
    
    Locale locale = FrameworkHelper.getUserLocale(request);


    String pid = request.getParameter("sasportal_portletid");
    // String pid = SpmPortletDisplayAction.getPortletId(request);
    
    // // System.out.println("");
    // // System.out.println("================== The pid is: " + pid + " ===========================================");
    // // System.out.println(""); 
    // // System.out.println("portalPg is: " + portalPg);
    
    String tabViewCompId = "tabviewComp" + pid;
    String tabViewId =     "tabview"  + pid;
    String saveSessionTabview = "session_tabview" + pid;
    String formPpid =       "SDESelectScorecardsForm" + pid;
    String formCompModelPpid  = SpmWebKey.SPM_FORM_COMPONENT_MODEL + pid;
    String formSelModelPpid = SpmWebKey.SPM_FORM_SELECTED_MODEL + pid;
    
    String tvcRefId = "tvtbl" + pid;
    String apId = "aptbl" + pid;
    String tvRefId = "tabviewRef" + pid;
    
    String inputFormId = (String) request.getAttribute(SpmPortletKey.SPM_INPUT_FORM);
    
    if (inputFormId == null)
        inputFormId = (String) request.getParameter(SpmPortletKey.SPM_INPUT_FORM);
        
    String inputFormParm = "";
    if (inputFormId != null)
       inputFormParm = "&" + SpmPortletKey.SPM_INPUT_FORM + "=" + inputFormId;

    Object someTabview = session.getAttribute(saveSessionTabview);
    if (someTabview != null)
    {
       session.setAttribute("tabview", someTabview);   // Share the tabview on the page.
       request.setAttribute("tabview", someTabview);
    }   


    // TableModel model = (TableModel)session.getAttribute(SpmPortletKey.SPM_TABLE_MODEL+pid); model = adapter
    
    SortableTableModelAdapter adapter =  (SortableTableModelAdapter) session.getAttribute(formCompModelPpid);    
        
    if (adapter == null)
    {  // Build a default model so error messages will display properly on the page
    
        // // System.out.println("The adapter is null!!!" + formCompModelPpid);
        String columnNames[] = new String[1];
        columnNames[0] = RB.getString("form.elementlabel.txt"/*I18nOK:LINE*/, locale);//"Element Label"; /*I18nOK:LINE*/ //TODO: fudge column 1 as row header       
        Object data[][] = new Object[1][columnNames.length];      
        String columnsToEdit = "";     
        DefaultTableModel dtm = new DefaultTableModel(data,columnNames);
        adapter = new SortableTableModelAdapter(dtm);
        // System.out.println("The adapter is" + adapter);
        session.setAttribute(formCompModelPpid, adapter);
        session.setAttribute(formSelModelPpid, columnsToEdit);
     }

    

    int columnCount = adapter.getColumnCount();
    int rowCount = adapter.getRowCount();
    
    int rowsPerPage = -1;
    int colsPerPage = -1;
    Integer irpp = (Integer) session.getAttribute(SpmPortletKey.SPM_ROW_SIZE + pid);
    Integer icpp = (Integer) session.getAttribute(SpmPortletKey.SPM_COL_SIZE + pid);
    
    if (irpp != null)
        rowsPerPage = irpp.intValue();
    else { // pick up the row size from the request in case it is passed in
		String numRows = request.getParameter( SpmPortletKey.SPM_ROW_SIZE );	
		if (numRows != null && numRows.length() != 0) {
			irpp = Integer.valueOf( numRows );
	   		session.setAttribute(SpmPortletKey.SPM_ROW_SIZE + pid, irpp);
           	rowsPerPage = irpp.intValue();
		}
    }
    
    if (icpp != null)
        colsPerPage = icpp.intValue();
    else { // pick up the col size from the request in case it is passed in
		String numCols = request.getParameter( SpmPortletKey.SPM_COL_SIZE );
		if (numCols != null && numCols.length() != 0) {
	   		icpp = Integer.valueOf( numCols );
	   		session.setAttribute(SpmPortletKey.SPM_COL_SIZE + pid, icpp);	   
           	colsPerPage = icpp.intValue();
		}
    }
        

    if (rowsPerPage < 1) 
       rowsPerPage = rowCount;
    else if (rowsPerPage > rowCount)
       rowsPerPage = rowCount;
    // else rowsPerPage +=1;
    
    if (colsPerPage < 1) 
       colsPerPage = columnCount;
    else if (colsPerPage > columnCount)
       colsPerPage = columnCount;
    else colsPerPage +=1;
        
    // send the row and page size on the request so the portlet has it while paging
    // This is specially done for the portlet because we don't have the state of the portlet available since
    // everything is on request
    inputFormParm += "&" + SpmPortletKey.SPM_COL_SIZE + "=" + (colsPerPage-1) + "&" + SpmPortletKey.SPM_ROW_SIZE + "=" + rowsPerPage;	

    String notFirstFlag = request.getParameter("SDEnotfirst"/*I18nOK:EMS*/);
    boolean bFirstTimeInPage = false;
    if(notFirstFlag == null || notFirstFlag.compareTo(""/*I18nOK:EMS*/) == 0)
       bFirstTimeInPage = true;
       
  

    // System.out.println("bFirstTimeInPage" + pid + " = " +  bFirstTimeInPage);
    HttpActionProvider apx = null;
    TableViewComposite tvcx = null;
    TableView tView = null;
      
    
    
    tvcx = (TableViewComposite) session.getAttribute(tvcRefId); 
    // System.out.println("tvcx2-0 is " + tvcx);

    
    if (!bFirstTimeInPage)
    {
       tvcx = (TableViewComposite) session.getAttribute(tvcRefId);
       // System.out.println("tvcx2-1 is " + tvcx);
              
       tView = (TableView) session.getAttribute(tvRefId);
       
       
       apx = (HttpActionProvider) session.getAttribute(apId);
       if (tvcx == null ||  apx == null || tView == null)
       {
          session.removeAttribute(tvcRefId);
          session.removeAttribute(tvRefId);
          session.removeAttribute(apId);
          session.removeAttribute("tabview");
          request.removeAttribute("tabview");
          bFirstTimeInPage = true;
          tvcx = null;
          tView = null;
          apx = null;
          bFirstTimeInPage = true;
        }
    }   
    
    if (tvcx != null)
       bFirstTimeInPage = false;
       

    String path = (String)request.getAttribute(SpmPortletKey.SPM_PATH);
    if (bFirstTimeInPage)
    {
       // System.out.println("Entered into bFirstTimeInPage " + pid);
       apx =  (HttpActionProvider) session.getAttribute(apId);
       if (apx == null)
       {
           apx = new HttpActionProvider();
	   apx.setControllerURL(path + "& ||=1");
	   apx.setLocale(locale);
	   session.setAttribute(apId, apx);
       }
       
       if (tView == null)
       {
           tView = new TableView(); 
	   tView.setAutoCreateColumnsFromModel(true);             
	   tView.setModel(adapter);
	   tView.setColumnPageSize(colsPerPage);
	   tView.setId(tabViewId);    
	   session.setAttribute(tvRefId, tView);
	   session.setAttribute(tabViewId, tView);
	   session.removeAttribute("tabview");
	   request.removeAttribute("tabview");
        }
       
       if (tvcx == null)
       {
           ActionOrderList zeroActionList = new ActionOrderList("ZeroActionList");
	   zeroActionList.setEnabledIfEmpty(false);
	   apx.setActionOrderList( ActionProviderSupportTypes.TABLEVIEW_SUPPORT, zeroActionList, null, HttpTableViewSupport.COLUMN_HEADER_AREA );
	   
	   tvcx = new TableViewComposite();
	   tvcx.setActionProvider(apx);
	   tvcx.setId(tabViewCompId);
	   tvcx.setModel(adapter);
       }
       else 
       {
          request.setAttribute(tvcRefId, tvcx);
          request.setAttribute(tvRefId, tView);
          request.setAttribute(tabViewId, tView);
          request.setAttribute(apId, apx);  // Probably not needed
          apx  = tvcx.getActionProvider();
          apx.executeCommand(request,response,out);
          // bFirstTimeInPage = false;
       }   

                  
       TableView tvData = (TableView)tvcx.getComponent( TableViewComposite.TABLEVIEW_TABLEDATA );
       
       tvData.setModel(adapter);
       tvData.setActionProvider(apx);
      
       session.setAttribute(tvcRefId, tvcx); 
       request.setAttribute(tvcRefId, tvcx);
       
       request.setAttribute(tvRefId, tView);
       session.setAttribute(tvRefId, tView);
       
       request.setAttribute(apId, apx);
       apx.executeCommand(request,response,out);
    }
    
    else // !bFirstTimeInPage
    {
        // System.out.println("Entered into NOT NOT NOT  bFirstTimeInPage " + pid);
        TableView tvData = (TableView)tvcx.getComponent( TableViewComposite.TABLEVIEW_TABLEDATA );
        apx  = tvcx.getActionProvider();
	tvData.setModel(adapter);
	tvData.setActionProvider(apx);
	tvcx.setModel(adapter);
	
	tView = (TableView) session.getAttribute(tvRefId);
        TableModel oldAdapter = tView.getModel();       
        if (oldAdapter != adapter)   // exact object compare is desired
        {
	    session.removeAttribute("tabview");
	    request.removeAttribute("tabview");
	}

	
	tView.setModel(adapter);
	
	session.setAttribute(tvcRefId, tvcx); 
	request.setAttribute(tvcRefId, tvcx);
	request.setAttribute(tvRefId, tView);
	request.setAttribute(apId, apx);
	
        apx.executeCommand(request,response,out);
	
    }
                             
                
   String validationFailedMessage    = RB.getString("form.dataentry.invalidnumber.txt",locale);
   String validationFailedCellPrefix = RB.getString("form.dataentry.invalidcellprefix.notrans.txt",locale);
   String formulaCellPrefix          = RB.getString("form.dataentry.formulacellprefix.notrans.txt",locale);
   String formulaCellSuffix          = RB.getString("form.dataentry.formulacellsuffix.notrans.txt",locale);
   String overriddenCellPrefix       = RB.getString("form.dataentry.overriddencellprefix.notrans.txt",locale);
   String overriddenCellSuffix       = RB.getString("form.dataentry.overriddencellsuffix.notrans.txt",locale);
    

   String nav = request.getParameter("CMDID");
   String sap = request.getParameter("APNAME");
   String commands = request.getParameter(SpmWebKey.SPM_COMMAND);
   
   
   boolean isCommandApplyReset = (commands != null && (commands.equals(SpmWebKey.SPM_TABLE_CUSTOM_APPLY) || commands.equals(SpmWebKey.SPM_TABLE_CUSTOM_RESET)));
   boolean isNavigation = ((nav != null && !nav.equals("")) && (sap != null && !sap.equals("")) && (!isCommandApplyReset) && !bFirstTimeInPage);

   if (!isNavigation)
   {        
    	session.removeAttribute(tabViewCompId);      	
   } 
    
    
   SDESelectScorecardsForm form = (SDESelectScorecardsForm)request.getAttribute("SDESelectScorecardsForm");
        
   if (form != null)
   {  // Merge & Persist the SDESelectScorecardsForm form unique to this portlet request on the session
      SDESelectScorecardsForm sessionForm = (SDESelectScorecardsForm) session.getAttribute(formPpid);
      // System.out.println("wizard.getxxx " + sessionForm);
      if (sessionForm != null)
          form.merge(sessionForm);
      else sessionForm = form;
      session.setAttribute(formPpid, sessionForm);
      request.setAttribute("SDESelectScorecardsForm", sessionForm);
   }
   
   request.removeAttribute("com.sas.web.title");
   session.removeAttribute("com.sas.web.title");
   request.removeAttribute("sas.framework.AppTitle");
   session.removeAttribute("sas.framework.AppTitle");

    
%>

<head>
            <sas-ui:ThemeStyles />
            <sas:InitializeComponents/>
            <sas:StyleSheet/>
</head>
<body>


<SCRIPT LANGUAGE="JavaScript">
// Override doAction so we can perform client-side validation first
function doAction(frm, cmd)
{
	// alert("doAction(): " + cmd);
	// We always use tableView_Form
	currentForm = document.forms["tableView_Form"];
	doSubmit = false;
	
	if (cmd == "cancel")
	    cmd = "javascript:refreshFrame%PNO";  // Use refresh frame in portlet 


	// If values have not changed, no need to validate, prompt, etc
	if( valueChanged() ) {
		// If cancel or choice change, confirm
	    if (cmd == "javascript:refreshFrame%PNO" || cmd == "same") {
			if( confirm("<%=RB.get("valueChangePrompt.txt", locale)%>") ) {
				// We don't need to validate since the user doesn't care about changes -- just submit
				doSubmit = true;
			}
    	} else {
			// Validate values before submit
		    if ( validateForm(currentForm) ) {
	    		doSubmit = true;
	    	}
	    }
    } else {
    	doSubmit = true;
    }
    
	if ( doSubmit ) {
	    currentForm.command.value=cmd;
	    // alert("The command is again" + cmd);
		currentForm.submit();
		disableEverything(); 	
	} else {
	    // reset the choiceboxes to their previous selections
		findElement(document.getElementById("<%=SpmWebKey.SPM_FORM_CHOICEBOX_NAME%>"),
		            "<%=(String)request.getAttribute(SpmWebKey.SPM_FORM_CHOICEBOX_SELECTED_MODEL)%>",
		            true);
		findElement(document.getElementById("<%=SpmWebKey.SPM_FORM_CURRENTPERIOD_CHOICEBOX_NAME%>"),
					"<%=(String)request.getAttribute(SpmWebKey.SPM_FORM_CURRENTPERIOD_CHOICEBOX_SELECTED_MODEL)%>",
					true);
	}
}

function doChoiceChange() 
{
	doAction(0, "same");
}

function valueChanged()
{
	//alert("valueChanged()");

	// Although not present in the _changedCells collection, changed values may have been cached 
	// as part of a previous table paging action. Check this first.
	var el = getElement("cachedChangedCellList");
	if (el.value != null && el.value != "") {
		return true;
	}

	// Now check the _changedCells collection for changes on the current table page	
	changed = false;
	currentForm = document.forms["tableView_Form"];
	formElements = currentForm.elements;
	changedCellsFound = false;
	elementCount = formElements.length
	i = 0;
	while(i < elementCount && !changedCellsFound)
	{
		if(formElements[i].name.indexOf("_changedCells") >= 0)
		{
			changedCellsFound = true;
			if(formElements[i].value.length > 0)
				changed = true;
		}
		i++;
	}

	return changed;
}

function findElement(theSelectObject, elemText, markAsSelected)
{
	var found = false;

	for (var i=0 ; i < theSelectObject.length ; i++)
	{
		//alert(theSelectObject.options[i].text + " / " + theSelectObject.options[i].value);
		
		//if ( theSelectObject.options[i].text == elemText )
		if ( theSelectObject.options[i].value == elemText )
		{
			//alert("Bingo");
			
			if (markAsSelected)
			{
				theSelectObject.options[i].selected = true;
			}
			
			found = true;
			break;
		}
	}	
}

// Assume that all input text elements are data entry cells in the table
function validateForm(frm)
{
	var invalidFloatRegexpr = /[^0123456789E.,+-]/;
	var floatPrefixRegexpr = /[+-]/;
	var floatMultiPrefixRegexpr = /[+-]{2,}/;
	var formulaCellPrefix			 = "<%=formulaCellPrefix%>";
    var formulaCellSuffix			 = "<%=formulaCellSuffix%>";
    var overriddenCellPrefix		 = "<%=overriddenCellPrefix%>";
    var overriddenCellSuffix		 = "<%=overriddenCellSuffix%>";
	
	//alert("validateForm(frm)");
	var formElements = frm.elements;
	var valid = true;
	for (var i = 0; i < formElements.length; i++) {
		var curElem = formElements[i];
		var curValue = curElem.value;
		//alert("Current element, type = " + curElem.type + ": " + curElem.name + " = [" + curValue + "]");
		var curValid = true;
		if (curElem.type == "text") {
			//alert("Current element: " + curElem.name + " = [" + curValue + "]");
			
			// First remove any cell augmentations
			var override = false;
			var preSufLength = overriddenCellPrefix.length + overriddenCellSuffix.length;
			if (curValue.length >= preSufLength) {
				if ( curValue.substr(0,overriddenCellPrefix.length) == overriddenCellPrefix
					 && curValue.substr(curValue.length-overriddenCellSuffix.length, overriddenCellSuffix.length) == overriddenCellSuffix) {
					curValue = curValue.substr(overriddenCellPrefix.length,curValue.length-preSufLength);
					//alert("overridden value:" + curValue);
					override = true;
				}
			}	

			if (!override) {
				preSufLength = formulaCellPrefix.length + formulaCellSuffix.length;			
				if (curValue.length >= preSufLength) {
					if ( curValue.substr(0,formulaCellPrefix.length) == formulaCellPrefix
						 && curValue.substr(curValue.length-formulaCellSuffix.length, formulaCellSuffix.length) == formulaCellSuffix) {
						curValue = curValue.substr(formulaCellPrefix.length,curValue.length-preSufLength);
						//alert("formula value:" + curValue);
					}
				}			
			}
           curValue = curValue.replace(new RegExp(/^\s+/),""); // START
			// Now validate			
			if (curValue == 0) {
				// Null values are OK
			} else {
				var result = parseFloat(curValue);
				//alert("Parse float:" + result);
				if ( isNaN(result) ) {
					// Blank values are OK
					// S0260368 - parseFloat does not validate entire string				
				} else if (curValue.search(floatMultiPrefixRegexpr) >= 0 ) {
					//alert("Two or more");
					curValid = false
				} else if (curValue.search(floatPrefixRegexpr) > 0 ) {
					//alert("Not at beginning");
					curValid = false;
				} else if (curValue.search(invalidFloatRegexpr) >= 0 ) {
						//alert("Invalid float");
						curValid = false;
				}
				
				if (!curValid) {
					valid = false;
					var temp = document.getElementById(formElements[i].id).value;
					document.getElementById(formElements[i].id).value = 
						"<%=validationFailedCellPrefix%>" + temp;	
				}		
			}
		}		
	}
	
	if (!valid) {
		alert("<%=validationFailedMessage%>");
	}
	
	return valid;
}
</SCRIPT>

<!--
<style> .textTableCell {
    horizontal-align: right;
}
</style>
-->
<span><div>


<table class="dataEntryBg" width="100%">
	<tr>
		<td>
			<!-- Note that the form name must be tableView_Form (required by tableview bean) -->
			<!-- DO NOT CHANGE FORM NAME --> 
			<!-- The sasportal_portletid is needed to show this is a portlet and suppress the banner -->
			<form name="tableView_Form" id="tableView_Form"
		      	action="DataEntryPortlet.do?sasportal_portletid=<%=pid%><%=inputFormParm%>"
		      	method="POST">

				<sas-f:Hidden name="SDEnotfirst" text="1"/>
				<sas-f:Hidden name="isSDEPortlet" text="1"/>

		</td>
	</tr>
	<tr>
	<!-- Move over just a bit from left side of container -->
		<td class="toppadding leftpadding rightpadding bottompadding">
			<table class="dataEntryBg" cellpadding="0" cellspacing="0">
				<tr>
					<td colspan="8">
						<table cellpadding=0 cellspacing=0>
							<tr>
								<td>
									<sas-ui:Help />
									<sas-ui:Message styleClass="solutionsSmallItem"/>
								</td>
							</tr>
						</table>
					</td>
				</tr>
<%
	                       
	                       String aDname = (String)request.getAttribute(SpmWebKey.SPM_FORM_PROJECTLABEL);
	                       ComboBoxModel cbm = (ComboBoxModel) request.getAttribute(SpmWebKey.SPM_FORM_CURRENTPERIODMODEL);
	                       String selectedItem = (String)request.getAttribute(SpmWebKey.SPM_FORM_CURRENTPERIOD_CHOICEBOX_SELECTED_MODEL);
	                       aDname += "  |  " + getDisplayStringFromComboBox(cbm, selectedItem);
	                       cbm = (ComboBoxModel) request.getAttribute(SpmWebKey.SPM_FORM_CHOICEBOX_MODEL);
	                       selectedItem = (String)request.getAttribute(SpmWebKey.SPM_FORM_CHOICEBOX_SELECTED_MODEL);
	                       aDname += "  |  " + getDisplayStringFromComboBox(cbm, selectedItem);
	                       aDname = Strings.escapeForJavaScript(aDname);
	                       aDname = aDname.replace("\\'", "'");
	                        

%>
				
			   <sas-ui:SectionView imgHide="section_hide" imgShow="section_show" 
	                       displayed="false" width="100%"  name="fixed" displayName="<%=aDname%>" >
	                       
		               <table>
				<tr>
					<td nowrap>
						<sas-ui:Text key="form.project.txt"/>
					</td>
					<td><table width="12px"></table></td>
					<td nowrap>
						<%=(String)request.getAttribute(SpmWebKey.SPM_FORM_PROJECTLABEL)%>
					</td>
				</tr>
				<tr height="4px"><td></td></tr>
				<tr>
					<td nowrap>
						<sas-ui:Text key="form.currentperiod.txt"/>
					</td>
					<td></td>
					<td>
						<sas-f:ChoiceBox
								name="<%=SpmWebKey.SPM_FORM_CURRENTPERIOD_CHOICEBOX_NAME%>"
								model="<%=SpmWebKey.SPM_FORM_CURRENTPERIODMODEL%>"	selectedItem="<%=(String)request.getAttribute(SpmWebKey.SPM_FORM_CURRENTPERIOD_CHOICEBOX_SELECTED_MODEL)%>"
								onChange="doChoiceChange()"
								/>
					</td>
					<td><table width="19px"></table></td>
					<td nowrap>
						<sas-ui:Text key="form.periodtype.txt"/>
					</td>
					<td><table width="12px"></table></td>
					<td nowrap>
						<%=(String)request.getAttribute(SpmWebKey.SPM_FORM_PERIODLABEL)%>
					</td>
					<td width="100%"></td>
				</tr>
				<tr height="4px"><td></td></tr>
				<tr>
					<td nowrap>
						<sas-ui:Text key="form.scorecard.txt"/>
					</td>
					<td></td>
					<td>
						<sas-f:ChoiceBox
								name="<%=SpmWebKey.SPM_FORM_CHOICEBOX_NAME%>"
								model="<%=SpmWebKey.SPM_FORM_CHOICEBOX_MODEL%>"	selectedItem="<%=(String)request.getAttribute(SpmWebKey.SPM_FORM_CHOICEBOX_SELECTED_MODEL)%>"
								onChange="doChoiceChange()"
								/>
					</td>
					<td></td>
					<td nowrap>
						<sas-ui:Text key="form.elementtype.txt"/>
					</td>
					<td></td>
					<td nowrap>
						<%=(String)request.getAttribute(SpmWebKey.SPM_FORM_ELEMENTTYPELABEL)%>
					</td>
				</tr>
				</table>
				</sas-ui:SectionView>
				
				<tr>
					<td colspan="8">
						<table cellpadding=0 cellspacing=0>
							<tr>
								<td>

									<sas-dv:TableViewComposite ref="<%=tvcRefId%>" scope="request" render="false">
										<sas-dv:TableView
											scope="request"
											ref="<%=tvRefId%>"
											formEnabled="false"
											id="tabview"
											cellSpacing="0"
										    cellPadding="5"
										    rowHeaderVisible="false"
										    rowPageSize="<%=rowsPerPage%>"
										    columnPageSize="<%=colsPerPage%>">
									
											<!-- Enable edit mode. The model specifies editable columns -->
											<sas:Edit enabled="true" singleRowEditing="false" editColumnVisible="false" editRowVisible="false">
												<%=request.getAttribute(formSelModelPpid)%>
											</sas:Edit>
										
											<sas:CellEditor>
												<sas-u:StyleInfo classid="textTableCell"/>
												<sas:CellContentsTextEntryEditor
													maximumLength="255"
													customAttributes="style='text-align:right'"
													/>
											</sas:CellEditor>
										
											<sas-dv:Rows>
												<sas-dv:Row startRow="1" repeatRowFactor="2" 
													styleClassPrefix="dataRow1_"/>
												<sas-dv:Row startRow="2" repeatRowFactor="2" 
													styleClassPrefix="dataRow2_"/>
											</sas-dv:Rows>
								
											<sas:Columns>
												<sas:Column modelIndex="0" hold="LEFT">
													<sas:ColumnHeaderRenderer>
														<sas-u:StyleInfo classid="tableHeader"/>
														<sas:CellContentsLabelRenderer encodeText="false" />
													</sas:ColumnHeaderRenderer>
													<sas-dv:CellRenderer>							
														<sas-u:StyleInfo classid="textTableCell"/>
													</sas-dv:CellRenderer>
												</sas:Column>
												<sas:ColumnHeaderRenderer>
													<sas-u:StyleInfo classid="tableHeader"/>
													<sas:CellContentsLabelRenderer encodeText="false" />
												</sas:ColumnHeaderRenderer>
												<sas-dv:CellRenderer>							
													<sas-u:StyleInfo classid="textTableCell"/>
												</sas-dv:CellRenderer>
											</sas:Columns>
										</sas-dv:TableView>
									</sas-dv:TableViewComposite>

<%
// TableViewComposite tvc = (TableViewComposite)session.getAttribute(tvcRefId);
TableViewComposite tvc = (TableViewComposite)request.getAttribute(tvcRefId);
// System.out.println("tvcId: " + tvcRefId);


TableView tv = (TableView)tvc.getComponent(tvc.TABLEVIEW_TABLEDATA);
tv.getFormObject().setName("tableView_Form");

if (bFirstTimeInPage)
{
	SimpleTemplate st = new SimpleTemplate("javascript: void(doPaging('tableView_Form', '%CMDID', '%APNAME'))");

/////////////////////////////////////////////////////////////////////////////////////////
// Change the NavBar's Actions
/////////////////////////////////////////////////////////////////////////////////////////
// Post 9.1.3: SHouldn't have to loop through action types to disable them.  Should be able to change
// 				strategy classes in the action provider framework.  See Neil Bell.
	TableRowNavigationBar rowNB = (TableRowNavigationBar)tvc.getComponent(tvc.TABLEVIEW_ROW_NAVIGATIONBAR);
	TableColumnNavigationBar colNB = (TableColumnNavigationBar)tvc.getComponent(tvc.TABLEVIEW_COLUMN_NAVIGATIONBAR);
	NavigationBarRowScrollingElement rowSE = (NavigationBarRowScrollingElement)rowNB.getComponent(rowNB.NAVIGATIONBAR_ROW_ELEMENT);
	NavigationBarColumnScrollingElement colSE = (NavigationBarColumnScrollingElement)colNB.getComponent(rowNB.NAVIGATIONBAR_COLUMN_ELEMENT);
	Collection areaTypes = rowSE.listAreaTypes();
	Iterator areaTypeIterator = areaTypes.iterator();
	while (areaTypeIterator.hasNext())
	{
		String areaType = (String)areaTypeIterator.next();
		Collection actionTypes = rowSE.listActionTypes(areaType);
		Iterator actionTypeIterator = actionTypes.iterator();
		while (actionTypeIterator.hasNext())
		{
			String actionType = (String)actionTypeIterator.next();
			HttpAction action = (HttpAction)apx.getDefaultAction( rowSE.getActionSupportType(), areaType, actionType);
			action.setURLTemplate(st);
		}
	}

	areaTypes = colSE.listAreaTypes();
	areaTypeIterator = areaTypes.iterator();
	while (areaTypeIterator.hasNext())
	{
		String areaType = (String)areaTypeIterator.next();
		Collection actionTypes = colSE.listActionTypes(areaType);
		Iterator actionTypeIterator = actionTypes.iterator();
		while (actionTypeIterator.hasNext())
		{
			String actionType = (String)actionTypeIterator.next();
			HttpAction action = (HttpAction)apx.getDefaultAction( colSE.getActionSupportType(), areaType, actionType);
			action.setURLTemplate(st);
		}
	}
}

%>

									<sas:TableViewComposite	ref="<%=tvcRefId%>" scope="request" render="true" />
								</td>
							</tr>
						</table>

						<script type="text/javascript">
							function doPaging(formName, cmdid, ap)
							{
							        // alert("We are being paged!!!");
								// Validate on each page change, although data is cached
								// until an explicit save action is requested
								if ( validateForm(document.forms[0]) )
								{
									sas_TableView_executeCmd(formName, cmdid, ap, '');
						  			disableEverything();  		
								}
							}
						</script>

						<input type="hidden" id="cachedChangedCellList" name="cachedChangedCellList" value="<%=request.getAttribute("cachedChangedCellList")%>"/>
						<input type="hidden" id="cachedChangedValueList" name="cachedChangedValueList" value="<%=request.getAttribute("cachedChangedValueList")%>"/>
					</td>
				</tr>		
			</table>
		</td>
	</tr>
</table>

<sas-ui:ButtonBar function="noDisable();" actionKey="SDEFormPortletButtons"/>


<script language="JavaScript" type="text/javascript">

<%
	boolean readOnlyRows[] = (boolean[]) request.getAttribute("_readOnlyRows_");
	if (readOnlyRows != null)
	{
	
	   out.println(" var disabledRows = new Array(" + readOnlyRows.length + "); ");
	   for (int ror = 0; ror < readOnlyRows.length; ror++)
		if (readOnlyRows[ror])
			out.println(" disabledRows[" + ror + "] = true; ");
	}
%>    
	/* mark rows as readonly */
	var isflag = 0;
	for (var di = 0; di < disabledRows.length; di++) {
		if (disabledRows[di] == null || !disabledRows[di]) {
			if(isflag == 0)
			   isflag = isflag + 1;
		   	continue; 
	   	}
		var jx = 1;
	    elem = document.getElementById("tabview" +  "_" + di + "_" + jx);
	    while (elem != null) {
			elem.disabled = true;
	        jx++;
	        elem = document.getElementById("tabview" +  "_" + di + "_" + jx);
		}
	}     
	if(isflag == 0)
		document.getElementById("SDESave").disabled = true;

<%
	boolean readOnlyCols[] = (boolean[]) request.getAttribute("_readOnlyCols_");
	if (readOnlyCols != null)
	{
	   out.println(" var disabledCols = new Array(" + readOnlyCols.length + "); ");
	   for (int roc = 0; roc < readOnlyCols.length; roc++)
		if (readOnlyCols[roc])
			out.println(" disabledCols[" + roc + "] = true; ");
        }			
%>
       
	
	for (var col = 0; col < disabledCols.length; col++) {
		var row = 0;  
	   	var elem = document.getElementById("tabview" +  "_" + row + "_" + col);
	    while (elem != null) {
	    //	elem.style.border = "0 solid black";
	    	if (disabledCols[col] == null || !disabledCols[col]) {
	    		// xx
	    	}else{
				elem.disabled = true;
				//elem.style.backgroundColor = "silver";
				elem.className = "menuDisabled"; //"promptComponentDisabled";
	    	}
	        row++;
	        elem = document.getElementById("tabview" +  "_" + row + "_" + col);
		}
	}
</script> 

</form>  <!-- name="tableView_Form" -->
</div></span>

</body>
<%
    someTabview = request.getAttribute("tabview");
    if (someTabview != null)
    {
      
       session.setAttribute(saveSessionTabview, someTabview);     
       session.removeAttribute("tabview");
    }   
  // request.removeAttribute("tabview");
  } // close synchronize body 
%>

<%!
static private Map stringLockMap = new HashMap();

private static synchronized String getLockString(String lockingStr)
{
    if (lockingStr == null)
        lockingStr = "null";
        
    String retStr = (String) stringLockMap.get(lockingStr);
    if (retStr == null)
    {
       retStr = new String(lockingStr);
       stringLockMap.put(retStr, retStr);
       retStr = (String) stringLockMap.get(lockingStr);
    }
    
    return retStr;
}

private static String getDisplayStringFromComboBox(ComboBoxModel cbm, String key)
{
   String retString = "";
   if (cbm == null || key == null)
      return retString;
      	
   int sz = cbm.getSize();
    	
   for (int ix = 0; ix < sz; ix++)
   {
      JavaScriptNode jsn = (JavaScriptNode) cbm.getElementAt(ix);
      if (key.equals(jsn.getValue()))
      {
         retString = jsn.getText();
         if (retString == null || retString.length() == 0)
         retString = jsn.getValue();
         break;
      }
   }
   return retString;
}

%>