<%-- Copyright (c) 2003 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved. --%>
<%@include file="shell/default.jspf"%>
<%@page import="java.util.Locale"%>

<%@page import="com.sas.framework.webapp.helpers.FrameworkHelper"%>
<%@page import="com.sas.actionprovider.support.ActionProviderSupportTypes"%>
<%@page import="com.sas.actionprovider.support.tableview.HttpTableViewSupport"%>
<%@page import="com.sas.actionprovider.ActionOrderList"%>

<%@taglib uri="http://www.sas.com/taglib/sas-dataviewers" prefix="sas-dv"%>
<%@taglib uri="http://www.sas.com/taglib/sas-form" prefix="sas-f"%>
<%@taglib uri="http://www.sas.com/taglib/sas-util" prefix="sas-u"%>

<%@page import="com.sas.solutions.spm.webapp.common.i18n.RB"%>

<%@page import="com.sas.servlet.tbeans.tableview.html.TableViewComposite"%>
<%@page import="com.sas.servlet.tbeans.tableview.html.TableView"%>
<%@page import="com.sas.util.SimpleTemplate"%>
<%@page import="com.sas.servlet.tbeans.navigationbar.html.TableRowNavigationBar"%>
<%@page import="com.sas.servlet.tbeans.navigationbar.html.NavigationBarRowScrollingElement"%>
<%@page import="com.sas.servlet.tbeans.navigationbar.html.TableColumnNavigationBar"%>
<%@page import="com.sas.servlet.tbeans.navigationbar.html.NavigationBarColumnScrollingElement"%>
<%@page import="java.util.Collection"%>
<%@page import="java.util.Iterator"%>
<%@page import="java.util.ArrayList"%>
<%@page import="com.sas.actionprovider.HttpAction"%>

<sas-ui:Page key="frmdatent"/>
<jsp:useBean id="apSDE" class="com.sas.actionprovider.HttpActionProvider" scope="session" />

<%
	Locale locale = FrameworkHelper.getUserLocale(request);
	//String pagingCtxStr = request.getContextPath() + "/SDEFormEntry.do?command=same&SDEnotfirst=1&" + SpmWebKey.SPM_ID + "=" + request.getParameter(SpmWebKey.SPM_ID);

    // Clear actions from action provider (so that default actions don't appear when a user clicks on the column headers)
	ActionOrderList zeroActionList = new ActionOrderList("ZeroActionList");
	zeroActionList.setEnabledIfEmpty(false);  // if none of the actions in this menu are enabled then don?t show this menu
	apSDE.setActionOrderList( ActionProviderSupportTypes.TABLEVIEW_SUPPORT, zeroActionList, null, HttpTableViewSupport.COLUMN_HEADER_AREA );

	String notFirstFlag = request.getParameter("SDEnotfirst"/*I18nOK:EMS*/);
	boolean bFirstTimeInPage = false;
	if(notFirstFlag == null || notFirstFlag.compareTo(""/*I18nOK:EMS*/) == 0)
		bFirstTimeInPage = true;
	if(!bFirstTimeInPage)
	{
		apSDE.executeCommand(request,response,out);
	}

   String validationFailedMessage = RB.getString("form.dataentry.invalidnumber.txt",locale);
   String validationFailedCellPrefix = RB.getString("form.dataentry.invalidcellprefix.notrans.txt",locale);
   String formulaCellPrefix			 = RB.getString("form.dataentry.formulacellprefix.notrans.txt",locale);
   String formulaCellSuffix			 = RB.getString("form.dataentry.formulacellsuffix.notrans.txt",locale);
   String overriddenCellPrefix		 = RB.getString("form.dataentry.overriddencellprefix.notrans.txt",locale);
   String overriddenCellSuffix		 = RB.getString("form.dataentry.overriddencellsuffix.notrans.txt",locale);

   // Temp workaround for paging bug in table model. If no data, an erroneous "page 1 of 0" message
   // is present when using a straight dtm. Using the adapter makes it disapper.
   //DefaultTableModel dtm = (DefaultTableModel)request.getAttribute(SpmWebKey.SPM_FORM_COMPONENT_MODEL);
   //SortableTableModelAdapter adapter = new SortableTableModelAdapter(dtm);
   //request.setAttribute(SpmWebKey.SPM_FORM_COMPONENT_MODEL, adapter);

	//session.setAttribute(SpmWebKey.SPM_FORM_COMPONENT_MODEL, adapter);

    String nav = request.getParameter("CMDID");
    String sap = request.getParameter("APNAME");
	String commands = request.getParameter(SpmWebKey.SPM_COMMAND);

	boolean isCommandApplyReset = (commands != null && (commands.equals(SpmWebKey.SPM_TABLE_CUSTOM_APPLY) || commands.equals(SpmWebKey.SPM_TABLE_CUSTOM_RESET)));
    boolean isNavigation = ((nav != null && !nav.equals("")) && (sap != null && !sap.equals("")) && (!isCommandApplyReset) && !bFirstTimeInPage);
    if (!isNavigation)
    {
    	session.removeAttribute("tabviewComp");
    	session.removeAttribute("tabview");
    }


%>

<SCRIPT LANGUAGE="JavaScript">
// Override doAction so we can perform client-side validation first
function doAction(frm, cmd)
{
	//alert("doAction(): " + cmd);
	// We always use tableView_Form
	currentForm = document.forms["tableView_Form"];
	doSubmit = false;

	// If values have not changed, no need to validate, prompt, etc
	if( valueChanged() ) {
		// If cancel or choice change, confirm
	    if (cmd == "cancel" || cmd == "same") {
			if( confirm("<%=RB.get("valueChangePrompt.txt", locale)%>") ) {
				// We don't need to validate since the user doesn't care about changes -- just submit
				doSubmit = true;
			}
    	} else {
			// Validate values before submit
		    if ( validateForm(currentForm) ) {
	    		doSubmit = true;
	    	}
	    }
    } else {
    	doSubmit = true;
    }

	if ( doSubmit ) {
	    currentForm.command.value=cmd;
		currentForm.submit();
		disableEverything();
	} else {
	    // reset the choiceboxes to their previous selections
		findElement(document.getElementById("<%=SpmWebKey.SPM_FORM_CHOICEBOX_NAME%>"),
		            "<%=(String)request.getAttribute(SpmWebKey.SPM_FORM_CHOICEBOX_SELECTED_MODEL)%>",
		            true);
		findElement(document.getElementById("<%=SpmWebKey.SPM_FORM_CURRENTPERIOD_CHOICEBOX_NAME%>"),
					"<%=(String)request.getAttribute(SpmWebKey.SPM_FORM_CURRENTPERIOD_CHOICEBOX_SELECTED_MODEL)%>",
					true);
	}
}

function doChoiceChange()
{
	doAction(0, "same");
}

function valueChanged()
{
	//alert("valueChanged()");

	// Although not present in the _changedCells collection, changed values may have been cached
	// as part of a previous table paging action. Check this first.
	var el = getElement("cachedChangedCellList");
	if (el.value != null && el.value != "") {
		return true;
	}

	// Now check the _changedCells collection for changes on the current table page
	changed = false;
	currentForm = document.forms["tableView_Form"];
	formElements = currentForm.elements;
	changedCellsFound = false;
	elementCount = formElements.length
	i = 0;
	while(i < elementCount && !changedCellsFound)
	{
		if(formElements[i].name.indexOf("_changedCells") >= 0)
		{
			changedCellsFound = true;
			if(formElements[i].value.length > 0)
				changed = true;
		}
		i++;
	}

	return changed;
}

function findElement(theSelectObject, elemText, markAsSelected)
{
	var found = false;

	for (var i=0 ; i < theSelectObject.length ; i++)
	{
		//alert(theSelectObject.options[i].text + " / " + theSelectObject.options[i].value);

		//if ( theSelectObject.options[i].text == elemText )
		if ( theSelectObject.options[i].value == elemText )
		{
			//alert("Bingo");

			if (markAsSelected)
			{
				theSelectObject.options[i].selected = true;
			}

			found = true;
			break;
		}
	}
}

// Assume that all input text elements are data entry cells in the table
function validateForm(frm)
{
	var invalidFloatRegexpr = /[^0123456789E.,+-]/;
	var floatPrefixRegexpr = /[+-]/;
	var floatMultiPrefixRegexpr = /[+-]{2,}/;
	var formulaCellPrefix			 = "<%=formulaCellPrefix%>";
    var formulaCellSuffix			 = "<%=formulaCellSuffix%>";
    var overriddenCellPrefix		 = "<%=overriddenCellPrefix%>";
    var overriddenCellSuffix		 = "<%=overriddenCellSuffix%>";
    var errorMessageSegment = "";

	//alert("validateForm(frm)");

	var formElements = frm.elements;
	var valid = true;


	var frm2 = document.forms["textFieldTypes_Form"];
        var flagElements = frm2.elements;


        var flaglen = flagElements.length;
        var flags = new Array(flaglen);


        var curFlag;
        var j;
        var elementName;


        for ( j=0; j < flaglen; j++ )
        {
          elementName = "cellType_" + j;
          flags[j] = flagElements[elementName].value;
        }


	j = 0;
	for (var i = 0; i < formElements.length; i++)
	{
		var curElem = formElements[i];
		var curValue = curElem.value;
		//alert("Current element, type = " + curElem.type + ": " + curElem.name + " = [" + curValue + "]");
		var curValid = true;




		if (curElem.type == "text")
		{
		        curFlag = flags[j++];
			//alert("Current element: " + curElem.name + " = [" + curValue + "], flag=[" + curFlag + "]");

			// First remove any cell augmentations
			var override = false;
			var preSufLength = overriddenCellPrefix.length + overriddenCellSuffix.length;
			if (curValue.length >= preSufLength) {
				if ( curValue.substr(0,overriddenCellPrefix.length) == overriddenCellPrefix
					 && curValue.substr(curValue.length-overriddenCellSuffix.length, overriddenCellSuffix.length) == overriddenCellSuffix) {
					curValue = curValue.substr(overriddenCellPrefix.length,curValue.length-preSufLength);
					//alert("overridden value:" + curValue);
					override = true;
				}
			}

			if (!override) {
				preSufLength = formulaCellPrefix.length + formulaCellSuffix.length;
				if (curValue.length >= preSufLength) {
					if ( curValue.substr(0,formulaCellPrefix.length) == formulaCellPrefix
						 && curValue.substr(curValue.length-formulaCellSuffix.length, formulaCellSuffix.length) == formulaCellSuffix) {
						curValue = curValue.substr(formulaCellPrefix.length,curValue.length-preSufLength);
						//alert("formula value:" + curValue);
					}
				}
			}
           curValue = curValue.replace(new RegExp(/^\s+/),""); // START
			// Now validate
			if (curValue == 0)
			{
				// Null values are OK
			}
			else
			{
			        if ( curFlag == 0 )
			        {
				  var result = parseFloat(curValue);
			  	  //alert("Parse float:" + result);
				  if ( isNaN(result) )
				  {
					// Blank values are OK
					// S0260368 - parseFloat does not validate entire string
				  }
				  else if (curValue.search(floatMultiPrefixRegexpr) >= 0 )
				  {
					//alert("Two or more");
					curValid = false
				  }
				  else if (curValue.search(floatPrefixRegexpr) > 0 )
				  {
					//alert("Not at beginning");
					curValid = false;
				  }
				  else if (curValue.search(invalidFloatRegexpr) >= 0 )
				  {
					//alert("Invalid float");
					curValid = false;
				  }
				}

			    if (!curValid) {
					valid = false;
					var temp = document.getElementById(formElements[i].id).value;
					document.getElementById(formElements[i].id).value =
						"<%=validationFailedCellPrefix%>" + temp;
					errorMessageSegment = "<%=validationFailedCellPrefix%>" + temp;
				}
			}
		}
	}

	if (!valid) {
		alert("<%=validationFailedMessage%>"+errorMessageSegment);
	}

	return valid;
}
</SCRIPT>

<!--
<style> .textTableCell {
    horizontal-align: right;
}
</style>
-->

<table class="dataEntryBg" width="100%">
	<tr>
		<td>
			<!-- Note that the form name must be tableView_Form (required by tableview bean) -->
			<!-- DO NOT CHANGE FORM NAME -->
			<form name="tableView_Form" id="tableView_Form"
		      	action="SDEFormEntry.do"
		      	method="POST">

				<sas-f:Hidden name="SDEnotfirst" text="1"/>
		</td>
	</tr>
	<tr>
	<!-- Move over just a bit from left side of container -->
		<td class="toppadding leftpadding rightpadding bottompadding">
			<table class="dataEntryBg" cellpadding="0" cellspacing="0">
				<tr>
					<td colspan="8">
						<table cellpadding=0 cellspacing=0>
							<tr>
								<td>
									<sas-ui:Help />
									<sas-ui:Message styleClass="solutionsSmallItem"/>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td nowrap>
						<sas-ui:Text key="form.project.txt"/>
					</td>
					<td><table width="12px"></table></td>
					<td nowrap>
						<%=(String)request.getAttribute(SpmWebKey.SPM_FORM_PROJECTLABEL)%>
					</td>
				</tr>
				<tr height="8px"><td></td></tr>
				<tr>
					<td nowrap>
						<sas-ui:Text key="form.currentperiod.txt"/>
					</td>
					<td></td>
					<td>
						<sas-f:ChoiceBox
								name="<%=SpmWebKey.SPM_FORM_CURRENTPERIOD_CHOICEBOX_NAME%>"
								model="<%=SpmWebKey.SPM_FORM_CURRENTPERIODMODEL%>"	selectedItem="<%=(String)request.getAttribute(SpmWebKey.SPM_FORM_CURRENTPERIOD_CHOICEBOX_SELECTED_MODEL)%>"
								onChange="doChoiceChange()"
								/>
					</td>
					<td><table width="19px"></table></td>
					<td nowrap>
						<sas-ui:Text key="form.periodtype.txt"/>
					</td>
					<td><table width="12px"></table></td>
					<td nowrap>
						<%=(String)request.getAttribute(SpmWebKey.SPM_FORM_PERIODLABEL)%>
					</td>
					<td width="100%"></td>
				</tr>
				<tr height="8px"><td></td></tr>
				<tr>
					<td nowrap>
						<sas-ui:Text key="form.scorecard.txt"/>
					</td>
					<td></td>
					<td>
						<sas-f:ChoiceBox
								name="<%=SpmWebKey.SPM_FORM_CHOICEBOX_NAME%>"
								model="<%=SpmWebKey.SPM_FORM_CHOICEBOX_MODEL%>"	selectedItem="<%=(String)request.getAttribute(SpmWebKey.SPM_FORM_CHOICEBOX_SELECTED_MODEL)%>"
								onChange="doChoiceChange()"
								/>
					</td>
					<td></td>
					<td nowrap>
						<sas-ui:Text key="form.elementtype.txt"/>
					</td>
					<td></td>
					<td nowrap>
						<%=(String)request.getAttribute(SpmWebKey.SPM_FORM_ELEMENTTYPELABEL)%>
					</td>
				</tr>
				<tr height="12px"><td></td></tr>
				<tr>
					<td colspan="8">
						<table cellpadding=0 cellspacing=0>
							<tr>
								<td>

									<sas-dv:TableViewComposite id="tabviewComp" model="<%=SpmWebKey.SPM_FORM_COMPONENT_MODEL%>" actionProvider="apSDE" scope="session" render="false">
										<sas-dv:TableView
											id="tabview"
											scope="session"
											formEnabled="false"
											cellSpacing="0"
										    cellPadding="5"
										    rowHeaderVisible="false"
                    								    rowPageSize="<%=((Integer)request.getAttribute(SpmWebKey.ROW_SIZE)).intValue()%>"
										    columnPageSize="9">

											<!-- Enable edit mode. The model specifies editable columns -->
											<sas:Edit enabled="true" singleRowEditing="false" editColumnVisible="false" editRowVisible="false">
												<%=session.getAttribute(SpmWebKey.SPM_FORM_SELECTED_MODEL)%>
											</sas:Edit>

											<sas:CellEditor>
												<sas-u:StyleInfo classid="textTableCell"/>
												<sas:CellContentsTextEntryEditor
													maximumLength="65535"
													customAttributes="style='text-align:right'"
													/>
											</sas:CellEditor>

											<sas-dv:Rows>
												<sas-dv:Row startRow="1" repeatRowFactor="2"
													styleClassPrefix="dataRow1_"/>
												<sas-dv:Row startRow="2" repeatRowFactor="2"
													styleClassPrefix="dataRow2_"/>
											</sas-dv:Rows>

											<sas:Columns>
												<sas:Column modelIndex="0" hold="LEFT">
													<sas:ColumnHeaderRenderer>
														<sas-u:StyleInfo classid="tableHeader"/>
														<sas:CellContentsLabelRenderer encodeText="false" />
													</sas:ColumnHeaderRenderer>
													<sas-dv:CellRenderer>
														<sas-u:StyleInfo classid="textTableCell"/>
													</sas-dv:CellRenderer>
												</sas:Column>
												<sas:ColumnHeaderRenderer>
													<sas-u:StyleInfo classid="tableHeader"/>
													<sas:CellContentsLabelRenderer encodeText="false" />
												</sas:ColumnHeaderRenderer>
												<sas-dv:CellRenderer>
													<sas-u:StyleInfo classid="textTableCell"/>
												</sas-dv:CellRenderer>
											</sas:Columns>
										</sas-dv:TableView>
									</sas-dv:TableViewComposite>

<%
TableViewComposite tvc = (TableViewComposite)session.getAttribute("tabviewComp");
TableView tv = (TableView)tvc.getComponent(tvc.TABLEVIEW_TABLEDATA);
tv.getFormObject().setName("tableView_Form");

if (bFirstTimeInPage)
{
	SimpleTemplate st = new SimpleTemplate("javascript: void(doPaging('tableView_Form', '%CMDID', '%APNAME'))");

/////////////////////////////////////////////////////////////////////////////////////////
// Change the NavBar's Actions
/////////////////////////////////////////////////////////////////////////////////////////
// Post 9.1.3: SHouldn't have to loop through action types to disable them.  Should be able to change
// 				strategy classes in the action provider framework.  See Neil Bell.
	TableRowNavigationBar rowNB = (TableRowNavigationBar)tvc.getComponent(tvc.TABLEVIEW_ROW_NAVIGATIONBAR);
	TableColumnNavigationBar colNB = (TableColumnNavigationBar)tvc.getComponent(tvc.TABLEVIEW_COLUMN_NAVIGATIONBAR);
	NavigationBarRowScrollingElement rowSE = (NavigationBarRowScrollingElement)rowNB.getComponent(rowNB.NAVIGATIONBAR_ROW_ELEMENT);
	NavigationBarColumnScrollingElement colSE = (NavigationBarColumnScrollingElement)colNB.getComponent(rowNB.NAVIGATIONBAR_COLUMN_ELEMENT);
	Collection areaTypes = rowSE.listAreaTypes();
	Iterator areaTypeIterator = areaTypes.iterator();
	while (areaTypeIterator.hasNext())
	{
		String areaType = (String)areaTypeIterator.next();
		Collection actionTypes = rowSE.listActionTypes(areaType);
		Iterator actionTypeIterator = actionTypes.iterator();
		while (actionTypeIterator.hasNext())
		{
			String actionType = (String)actionTypeIterator.next();
			HttpAction action = (HttpAction)apSDE.getDefaultAction( rowSE.getActionSupportType(), areaType, actionType);
			action.setURLTemplate(st);
		}
	}

	areaTypes = colSE.listAreaTypes();
	areaTypeIterator = areaTypes.iterator();
	while (areaTypeIterator.hasNext())
	{
		String areaType = (String)areaTypeIterator.next();
		Collection actionTypes = colSE.listActionTypes(areaType);
		Iterator actionTypeIterator = actionTypes.iterator();
		while (actionTypeIterator.hasNext())
		{
			String actionType = (String)actionTypeIterator.next();
			HttpAction action = (HttpAction)apSDE.getDefaultAction( colSE.getActionSupportType(), areaType, actionType);
			action.setURLTemplate(st);
		}
	}
}

%>

									<sas:TableViewComposite	ref="tabviewComp" actionProvider="apSDE" scope="session" render="true" />
								</td>
							</tr>
						</table>

						<script type="text/javascript">
							function doPaging(formName, cmdid, apSDE)
							{
								// Validate on each page change, although data is cached
								// until an explicit save action is requested
								if ( validateForm(document.forms[0]) )
								{
									sas_TableView_executeCmd(formName, cmdid, apSDE, '');
						  			disableEverything();
								}
							}
						</script>

						<input type="hidden" id="cachedChangedCellList" name="cachedChangedCellList" value="<%=request.getAttribute("cachedChangedCellList")%>"/>
						<input type="hidden" id="cachedChangedValueList" name="cachedChangedValueList" value="<%=request.getAttribute("cachedChangedValueList")%>"/>
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>

<sas-ui:ButtonBar function="noDisable();" actionKey="SDEFormButtons"/>


<script language="JavaScript" type="text/javascript">

<%
	boolean readOnlyRows[] = (boolean[]) request.getAttribute("_readOnlyRows_");
	out.println(" var disabledRows = new Array(" + readOnlyRows.length + "); ");

	for (int ror = 0; ror < readOnlyRows.length; ror++)
		if (readOnlyRows[ror])
			out.println(" disabledRows[" + ror + "] = true; ");
%>
	/* mark rows as readonly */
	var isflag = 0;
	for (var di = 0; di < disabledRows.length; di++) {
		if (disabledRows[di] == null || !disabledRows[di]) {
			if(isflag == 0)
			   isflag = isflag + 1;
		   	continue;
	   	}
		var jx = 1;
	    elem = document.getElementById("tabview_" + di + "_" + jx);
	    while (elem != null) {
			elem.disabled = true;
	        jx++;
	        elem = document.getElementById("tabview_" + di + "_" + jx);
		}
	}
	if(isflag == 0)
		document.getElementById("SDESave").disabled = true;

<%
	boolean readOnlyCols[] = (boolean[]) request.getAttribute("_readOnlyCols_");
	out.println(" var disabledCols = new Array(" + readOnlyCols.length + "); ");

	for (int roc = 0; roc < readOnlyCols.length; roc++)
		if (readOnlyCols[roc])
			out.println(" disabledCols[" + roc + "] = true; ");
%>


	for (var col = 0; col < disabledCols.length; col++) {

		var row = 0;
	   	var elem = document.getElementById("tabview_" + row + "_" + col);

	    while (elem != null) {

	    //	elem.style.border = "0 solid black";
	    	if (disabledCols[col] == null || !disabledCols[col]) {
	    		// xx
	    	}else{
				elem.disabled = true;
				//elem.style.backgroundColor = "silver";
				elem.className = "menuDisabled"; //"promptComponentDisabled";

	    	}
	        row++;
	        elem = document.getElementById("tabview_" + row + "_" + col);
		}
	}
</script>

</form>

<form name="textFieldTypes_Form" id="textFieldTypes_Form">
<%
   int index;
   String name,flag;
   ArrayList<ArrayList<String>> cellTypes;
   Iterator<ArrayList<String>> iter1;
   ArrayList<String> ctypes;
   Iterator<String> iter2;
   StringBuffer sb;

   cellTypes = (ArrayList<ArrayList<String>>)request.getAttribute("cellTypeList");
   index = 0;
   sb = new StringBuffer(20);


   for ( iter1=cellTypes.iterator(); iter1.hasNext(); )
   {
      ctypes = iter1.next();

      for ( iter2=ctypes.iterator(); iter2.hasNext(); )
      {
         flag = iter2.next();
         sb.setLength(0);
         sb.append("cellType_").append(index);
         name = sb.toString();

%>
     <input type="hidden" id="<%=name%>" name="<%=name%>" value="<%=flag%>"/>

<%
         index += 1;
      }
   }

%>

</form>

